#!/bin/bash

rbscript="./f77tof90.rb"
orgsrcdir="./cntnm/src"
newsrcdir="./src"

nowrite="--nowrite"
nowrite=""

# convert codes from Fortran77 to Fortran90
#
ruby ${rbscript} -i ${orgsrcdir}/contnm.f ${nowrite} > ${newsrcdir}/contnm.f90
#
# insert a line (to avoid grammar error?)
#
sed -i -e "3976i         fo2(j) = 0." ${newsrcdir}/contnm.f90
#
ruby ${rbscript} -i ${orgsrcdir}/cntnm_progr.f \
    | sed s/contnm.f/contnm.f90/g \
    | sed s/8.314472\ \ E+07/8.314472E+07/g > ${newsrcdir}/cntnm_progr.f90
#
# split a code (create a separate file which contains procedures only)
#
tail -156 ${newsrcdir}/cntnm_progr.f90 > ${newsrcdir}/cntnm_progr_procedures.f90
#
# create contnm_mod.f90 by modifing following points in contnm.f90
#   * xlength is added to argument of subroutine contnm
#   * WTOT is calculated by WTOT = XLOSMT*(PAVE/1013.)*(273./TAVE)* xlength
sed -e '237,240d' ${newsrcdir}/contnm.f90 \
    | sed -e '237i \ \ \ WTOT = XLOSMT*(PAVE/1013.)*(273./TAVE)* xlength' \
    | sed s/"SUBROUTINE\ CONTNM(JRAD)"/"SUBROUTINE\ CONTNM(JRAD,xlength)"/ \
    > ${newsrcdir}/contnm_mod.f90
sed s/contnm.f90/contnm_mod.f90/g ${newsrcdir}/cntnm_progr_procedures.f90 > ${newsrcdir}/cntnm_progr_procedures_mod.f90


## make test program cntnm_progr_no_n2_o2_rf.f90
#sed    -e "114i !      No N2 nor O2" ${newsrcdir}/cntnm_progr.f90 > ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90
#sed -i -e "115i \      xcnt(5)=0.0" ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90
#sed -i -e "116i \      xcnt(6)=0.0" ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90
#sed -i -e "117i \      xcnt(7)=0.0" ${newsrcdir}/cntnm_progr_no_n2_o2_rf.f90

# make test program V1
head -308 ${newsrcdir}/cntnm_progr.f90 > ${newsrcdir}/test01_main.f90
echo "      Include 'cntnm_progr_procedures.f90'" >> ${newsrcdir}/test01_main.f90

# make test program V2
head -306 ${newsrcdir}/cntnm_progr.f90 | sed s/PROGRAM\ DRCNTNM/!PROGRAM\ DRCNTNM/g > ${newsrcdir}/test02_cntnm_progr_core.f90

