#!/usr/bin/ruby
require "numru/ggraph"
include NumRu

path = "out_dwn1e2/Wordsworth2010_CO2-1.0_Dry_Ps1e5Pa_2Layer_ac.nc"
path = "out_dwn1e0/Wordsworth2010_CO2-1.0_Dry_Ps1e5Pa_2Layer_ac.nc"
vname = 'AbsCoef'
gp = GPhys::NetCDF_IO.open( path, vname )

gp = gp.cut('MolNum'=>2).cut('Press'=>1e5)

gp = gp * 1.0e5 / ( 1.38e-23 * 273.0 )
gp.units = 'm|-1"'
z = gp.axis("WaveNum").pos.convert_units( Units['cm-1'] )
z.long_name = 'wavenumber'
gp.axis("WaveNum").set_pos(z)
gp.long_name = "absorption coefficient"

print "1: Display,  2: File\n"
citr = gets
citr = citr.chomp!
DCL.gropn(citr.to_i)

#DCL.sldiv('y',4,2)
DCL.sgpset('lcntl',true)
DCL.sgpset('lfull',true)
DCL.uzfact(0.75)
DCL.sgpset('lfprop',true)
DCL.sglset('lclip',true)

svx1 = 0.2; svx2 = 0.9; svy1 = 0.15; svy2 = 0.6

gp = gp + 1.0e-10
GGraph.set_fig 'itr'=>2, 'viewport'=>[svx1,svx2,svy1,svy2], 'window'=>[0,2000,1e-5,1e4]

GGraph.set_axes('ylabelint'=>2)

GGraph.line gp, true , "exchange"=>false, "title"=>"", 'annotate'=>false

DCL.grcls
