    program main

      use vtype_module
      use const_module
      use cntnm_module

      implicit none

      integer(i4b)              :: nwnsl
      real(dp)    , allocatable :: wn( : ), od( :, : )
      real(dp)    , allocatable :: od_tmp( :, : )

      real(dp)                  :: wns, wne, dwn

      integer(i4b)              :: km
      real(dp)    , allocatable :: gph( : ), gp( : ), gt( : ), &
           gmmmass( : ), gcnd_tot( : ), &
           gvmr_h2o( : ), gvmr_co2( : ), gvmr_o3( : ), gvmr_o2( : ), gvmr_n2( : )

      real(dp)                  :: press, temp, &
           vmr_h2o, vmr_co2, vmr_o3, vmr_o2, vmr_n2

      integer(i4b)              :: k, m


      call const_set( 0 )


      km = 1

      allocate( gph( km+1 ), gp( km ), gt( km ), gmmmass( km ), gcnd_tot( km ), &
           gvmr_h2o( km ), gvmr_co2( km ), gvmr_o3( km ), gvmr_o2( km ), gvmr_n2( km ) )


      press   = 1013.0d2
      temp    =  296.0d0

      vmr_n2  =   0.78d0
      vmr_o2  =   0.21d0
      vmr_o3  =   0.0d0
      vmr_co2 = 345.0d-6
      vmr_h2o =   0.01d0

      do k = 1, km
         gp( k ) = press
         gt( k ) = temp

         gvmr_h2o( k ) = vmr_h2o
         gvmr_co2( k ) = vmr_co2
         gvmr_o3 ( k ) = vmr_o3
         gvmr_o2 ( k ) = vmr_o2
         gvmr_n2 ( k ) = vmr_n2
      end do


      do k = 1, km
         gmmmass( k ) = 0.0d0
      end do
      do k = 1, km
         gmmmass( k ) = gmmmass( k ) &
              + 18.0d0 * gvmr_h2o( k ) &
              + 44.0d0 * gvmr_co2( k ) &
              + 48.0d0 * gvmr_o3 ( k ) &
              + 32.0d0 * gvmr_o2 ( k ) &
              + 28.0d0 * gvmr_n2 ( k )
      end do
      do k = 1, km
         gmmmass( k ) = gmmmass( k ) * amu
      end do


      gph( 1 ) = 0.0d0
      do k = 1, km
         gcnd_tot( k ) = gp( k ) / ( boltz * gt( k ) ) * 1.0d-2

         gph( k+1 ) = gph( k ) + gcnd_tot( k ) * ( grav * gmmmass( k ) )
      end do



      wns =    0.0d2
      wne = 5000.0d2
      dwn =   10.0d2


      nwnsl = ( wne - wns ) / dwn + 1
      allocate( wn( nwnsl ), od( nwnsl, km ) )

      allocate( od_tmp( nwnsl, km ) )

      do m = 1, nwnsl
         wn( m ) = dwn * dble( m - 1 ) + wns
      end do


      call cntnm_interface( km, gp, gt, gcnd_tot, &
           gvmr_h2o, gvmr_co2, gvmr_o3, gvmr_o2, gvmr_n2, &
           nwnsl, wn, od, 1, nwnsl )


      od_tmp( :, : ) = od( :, : )


!!$      call cntnm_init_old( km, gp, gt, gcnd_tot, &
!!$           gvmr_h2o, gvmr_co2, gvmr_o2, gvmr_n2 )
      call cntnm_init( km, gph, gp, gt, gmmmass, &
           gvmr_h2o, gvmr_co2, gvmr_o3, gvmr_o2, gvmr_n2 )
      call cntnm_get_od( km, nwnsl, wn, od, 1, nwnsl )


      do m = 1, nwnsl
         write( 61, * ) m, wn( m ), od( m, 1 ), od_tmp( m, 1 )
      end do



!!$      press   = 1013.0d2
!!$      temp    =  296.0d0
!!$
!!$      vmr_n2  =   0.78d0
!!$      vmr_o2  =   0.21d0
!!$      vmr_ar  =   0.009d0
!!$      vmr_co2 = 345.0d-6
!!$      vmr_h2o =   0.01d0
!!$
!!$
!!$      cnd_tot = press / ( boltz * temp ) * 1.0d-2 * 1.0d6
!!$
!!$
!!$      wns =    0.0d0
!!$      wne = 5000.0d0
!!$      dwn =   10.0d0
!!$
!!$
!!$      nwn = 5050
!!$      allocate( wn( nwn ), absrb( nwn ) )
!!$
!!$
!!$      call drcntnm( press, temp, cnd_tot, &
!!$           vmr_n2, vmr_o2, vmr_ar, vmr_co2, vmr_h2o, &
!!$           wns, wne, dwn, nwn, absrb )
!!$
!!$
!!$      do m = 1, nwn
!!$         wn( m ) = dwn * dble( m - 1 ) + wns
!!$         if( absrb( m ) .ge. 0.0d0 ) then
!!$            write( 61, * ) m, wn( m ), absrb( m )
!!$         end if
!!$      end do


    end program main
