#!/bin/bash

a_sym=( \
    "Halthore2005_SubArcWinter_CO2-360ppmv" \
    "Halthore2005_Tropics_CO2-360ppmv" \
    "Halthore2005_SubArcWinter_CO2-360ppmv_Cld" \
    "Halthore2005_Tropics_CO2-360ppmv_Cld" \
)

in_prof_dir_0="../prog01.4_mkprofile_Halthore2005/out"
in_ac_dir_0="../prog02.0_calc_ac/out-dwn1e1"

out_dir_0="out-dwn1e1_sza"
a_dir_sza=( "030" "075" )
a_dir_wl=( "0.28-5.00" "0.20-0.35" "0.35-0.70" "0.70-5.00" )

a_sza=( 30.0d0 75.0d0 )
# 0.28-5.00 micron
# 0.20-0.35 micron
# 0.35-0.70 micron
# 0.70-5.00 micron
a_wns=(  200000.0d0 2857143.0d0 1428571.0d0  200000.0d0 )
a_wne=( 3571428.0d0 5000000.0d0 2857143.0d0 1428571.0d0 )


for ((i=0; i < ${#a_sym[*]}; i++))
do
    for ((j=0; j < ${#a_dir_sza[*]}; j++))
    do
	for ((k=0; k < ${#a_dir_wl[*]}; k++))
	do
	    inprofncf=$in_prof_dir_0"/"${a_sym[$i]}".nc"
	    inacncf=$in_ac_dir_0"/"${a_sym[$i]}"_ac.nc"
	    outdir=$out_dir_0${a_dir_sza[$j]}"_"${a_dir_wl[$k]}
	    outncf_flux=$outdir"/"${a_sym[$i]}"_Flux.nc"
	    outncf_tend=$outdir"/"${a_sym[$i]}"_Tendency.nc"
	    echo "-----"
	    if [ ! -e $outdir ]; then
		echo "Directory "$outdir" does not exist."
		#mkdir $outdir
		exit
	    fi
	    echo $inprofncf
	    echo $inacncf
	    echo 'wavenumber:' ${a_wns[$k]} '-' ${a_wne[$k]}
	    echo 'sza       :' ${a_sza[$j]}
	    echo $outncf_flux
	    echo $outncf_tend
	    cat Halthore2005_template_calc_rte.conf \
		| sed -e s@SEDWAVENUMSTART@${a_wns[$k]}@g \
		| sed -e s@SEDWAVENUMEND@${a_wne[$k]}@g \
		| sed -e s@SEDSZA@${a_sza[$j]}@g \
		      > calc_rte.conf
	    cat Halthore2005_template_calc_rte_file.conf \
		| sed -e s@SEDINPROFNCF@$inprofncf@g \
		| sed -e s@SEDINACNCF@$inacncf@g \
		| sed -e s@SEDOUTFLUXNCF@$outncf_flux@g \
		| sed -e s@SEDOUTTENDNCF@$outncf_tend@g \
		      > calc_rte_file.conf
	    ./calc_rte
	done
    done
done

