#!/usr/bin/ruby
require "numru/ggraph"
include NumRu

dir0 = "out-dwn1e1"
szas = ["030", "075"]
wls  = ["0.28-5.00", "0.20-0.35", "0.35-0.70", "0.70-5.00"]
fns  = ["Halthore2005_SubArcWinter_CO2-360ppmv_Flux.nc",
        "Halthore2005_Tropics_CO2-360ppmv_Flux.nc", 
        "Halthore2005_SubArcWinter_CO2-360ppmv_Cld_Flux.nc",
        "Halthore2005_Tropics_CO2-360ppmv_Cld_Flux.nc"]

for fn in fns
  for sza in szas
    print "SZA = " + sza + ", File: " + fn + "\n"
    #
    # downward flux at surface
    print "  downward flux at surface\n"
    for wl in wls
      path = dir0 + "_sza" + sza + "_" + wl + "/" + fn
      #p path
      vname = 'RadUwFluxSW'
      gpupfl = GPhys::NetCDF_IO.open( path, vname )
      vname = 'RadDwFluxSW'
      gpdnfl = GPhys::NetCDF_IO.open( path, vname )
      #
      print "    " + wl + ": " + gpdnfl.val[0].to_s + "\n"
    end
    #
    # upward flux at TOA
    print "  upward flux at TOA\n"
    for wl in wls
      path = dir0 + "_sza" + sza + "_" + wl + "/" + fn
      #p path
      vname = 'RadUwFluxSW'
      gpupfl = GPhys::NetCDF_IO.open( path, vname )
      vname = 'RadDwFluxSW'
      gpdnfl = GPhys::NetCDF_IO.open( path, vname )
      #
      print "    " + wl + ": " + gpupfl.val[-1].to_s + "\n"
    end
    #
    # absorptance
    print "  absorptance\n"
    for wl in wls
      path = dir0 + "_sza" + sza + "_" + wl + "/" + fn
      #p path
      vname = 'RadUwFluxSW'
      gpupfl = GPhys::NetCDF_IO.open( path, vname )
      vname = 'RadDwFluxSW'
      gpdnfl = GPhys::NetCDF_IO.open( path, vname )
      #
      abstnc = - ( ( gpupfl.val[-1] - gpdnfl.val[-1] ) - ( gpupfl.val[0] - gpdnfl.val[0] ) ) / gpdnfl.val[-1]
      print "    " + wl + ": " + abstnc.to_s + "\n"
    end
  end
end

