# coding: utf-8
require "numru/ggraph"
include NumRu

sol = 88800.0

casename = ["6 mb water", "6 mb nowater", "500 mb water", "500 mb nowater"]

dirs = [
  "../../prog03_calc_rte/out_dwn1e0", 
  "../../prog03_calc_rte/out_dwn1e0_abw1.0", 
  "../../prog03_calc_rte/out_dwn1e0_noCIAL", 
  "../../prog03_calc_rte/out_dwn1e0_noCIA", 
  "../../prog03_calc_rte/out_dwn1e0_CO2co025", 
  "../../prog03_calc_rte/out_dwn1e0_CO2co100", 
  "../../prog03_calc_rte/out_dwn1e0_CO2co250"
]

ncfns_model = [
  [
    "Mischna2012_Mars_006mb_LW_Flux.nc", 
    "Mischna2012_Mars_006mb_LW_Flux.nc", 
    "Mischna2012_Mars_006mb_LW_Tendency.nc",
    "Mischna2012_Mars_006mb_SW_Flux.nc", 
    "Mischna2012_Mars_006mb_SW_Flux.nc", 
    "Mischna2012_Mars_006mb_SW_Tendency.nc"
  ],
  [
    "Mischna2012_Mars_006mb_Dry_LW_Flux.nc", 
    "Mischna2012_Mars_006mb_Dry_LW_Flux.nc", 
    "Mischna2012_Mars_006mb_Dry_LW_Tendency.nc",
    "Mischna2012_Mars_006mb_Dry_SW_Flux.nc", 
    "Mischna2012_Mars_006mb_Dry_SW_Flux.nc", 
    "Mischna2012_Mars_006mb_Dry_SW_Tendency.nc"
  ],
  [
    "Mischna2012_Mars_500mb_LW_Flux.nc", 
    "Mischna2012_Mars_500mb_LW_Flux.nc", 
    "Mischna2012_Mars_500mb_LW_Tendency.nc",
    "Mischna2012_Mars_500mb_SW_Flux.nc", 
    "Mischna2012_Mars_500mb_SW_Flux.nc", 
    "Mischna2012_Mars_500mb_SW_Tendency.nc"
  ],
  [
    "Mischna2012_Mars_500mb_Dry_LW_Flux.nc", 
    "Mischna2012_Mars_500mb_Dry_LW_Flux.nc", 
    "Mischna2012_Mars_500mb_Dry_LW_Tendency.nc",
    "Mischna2012_Mars_500mb_Dry_SW_Flux.nc", 
    "Mischna2012_Mars_500mb_Dry_SW_Flux.nc", 
    "Mischna2012_Mars_500mb_Dry_SW_Tendency.nc"
  ]
]

vnames = ["RadDwFluxLW", "RadUwFluxLW", "DTempDtLW", "RadDwFluxSW", "RadUwFluxSW", "DTempDtSW"]
longnames = ["lw.dn.flux.diff.", "lw.up.flux.diff.", "lw.tendency.diff.", "sw.dn.flux.diff.", "sw.up.flux.diff.", "sw.tendency.diff."]

#                      k  j  1    k  j  2
xlim = [
  [
    [ -0.2,   0.2], #[  0.0,  50.0], # [0][0][0], [0][0][1]
    [ -0.2,   0.2], #[205.0, 225.0], # [0][1][0], [0][1][1]
    [ -1.0,   1.0], #[-80.0,   0.0], # [0][2][0], [0][2][1]
    [ -0.2,   0.2], #[286.0, 293.0], # [0][3][0], [0][3][1]
    [ -0.2,   0.2], #[ 57.0,  59.0], # [0][4][0], [0][4][1]
    [ -1.0,   1.0]  #[  0.0, 120.0]  # [0][5][0], [0][5][1]
  ],
  [
    [ -0.2,   0.2], #[  0.0,  50.0], # [0][0][0], [0][0][1]
    [ -0.2,   0.2], #[205.0, 225.0], # [0][1][0], [0][1][1]
    [ -1.0,   1.0], #[-80.0,   0.0], # [0][2][0], [0][2][1]
    [ -0.2,   0.2], #[286.0, 293.0], # [0][3][0], [0][3][1]
    [ -0.2,   0.2], #[ 57.0,  59.0], # [0][4][0], [0][4][1]
    [ -1.0,   1.0]  #[  0.0, 120.0]  # [0][5][0], [0][5][1]
  ],
  [
    [ -2.0,   2.0], #[  0.0, 200.0], # [2][0][0], [2][0][1]
    [ -2.0,   2.0], #[100.0, 230.0], # [2][1][0], [2][1][1]
    [ -0.2,   0.2], #[-20.0,   0.0], # [2][2][0], [2][2][1]
    [ -2.0,   2.0], #[150.0, 230.0], # [2][3][0], [2][3][1]
    [ -2.0,   2.0], #[ 30.0,  66.0], # [2][4][0], [2][4][1]
    [ -0.2,   0.2]  #[  0.0,  10.0]  # [2][5][0], [2][5][1]
  ],
  [
    [ -2.0,   2.0], #[  0.0, 200.0], # [2][0][0], [2][0][1]
    [ -2.0,   2.0], #[100.0, 230.0], # [2][1][0], [2][1][1]
    [ -0.2,   0.2], #[-20.0,   0.0], # [2][2][0], [2][2][1]
    [ -2.0,   2.0], #[150.0, 230.0], # [2][3][0], [2][3][1]
    [ -2.0,   2.0], #[ 30.0,  66.0], # [2][4][0], [2][4][1]
    [ -0.2,   0.2]  #[  0.0,  10.0]  # [2][5][0], [2][5][1]
  ]
]

ylim = [
  [  10e2, 1e-1], # [0][0], [0][1]
  [  10e2, 1e-1], # [1][0], [1][1]
  [1000e2, 1e-1], # [2][0], [2][1]
  [1000e2, 1e-1]  # [3][0], [3][1]
]


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)


DCL.sldiv('y',3,2)
DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
#DCL.uzfact(0.6)
DCL.uzfact(1.2)
DCL.sglset('LCLIP', true)
DCL.sglset('LCNTL', true)

for k in 0..casename.size-1 do
  y1 = ylim[k][0]
  y2 = ylim[k][1]
  for j in 0..vnames.size-1 do
    vname = vnames[j]

    x1 = xlim[k][j][0]
    x2 = xlim[k][j][1]

    GGraph.set_fig 'itr'=> 2, 'viewport'=>[0.2,0.8,0.2,0.85],
                   'window'=>[x1,x2,y1,y2]
#                   'window'=>[x1s[j],x2s[j],y1,y2]
#               'window'=>[0,1,0.0,100]

    idir = 0
    ncfn = dirs[idir]+"/"+ncfns_model[k][j]
    gphys0 = GPhys::IO.open( ncfn, vname )

    for idir in 1..dirs.size-1
      if idir == 1 then
        flag_first = true
      else
        flag_first = false
      end

      ncfn = dirs[idir]+"/"+ncfns_model[k][j]

      gphys = GPhys::IO.open( ncfn, vname )

      gphys = gphys - gphys0

      gphys = gphys.copy
      gphys.long_name = longnames[j]
      if j.modulo(3) == 2 then
        gphys = gphys * sol
        gphys.units = "K (sol)-1"
      end
      if j == 1 then
        title = casename[k]
      else
        title = ""
      end
      if j == 0 then
        legend = dirs[idir][dirs[idir].rindex("_")+1..dirs[idir].size-1]
      else
        legend = nil
      end

      GGraph.line gphys, flag_first, 'exchange'=>true, 'title'=>title,
                  'index'=> 10*(idir+2)+1,
                  'legend'=>legend, 'legend_vx'=>0.5, 'legend_vy'=>0.75-idir*0.05
    end

  end

end

DCL.grcls
