require "numru/ggraph"
include NumRu

ncfn = "../prog03_calc_rte/out-hitemp-dwn1e1/Venus_VIRA+GasVMR+CldMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc"
ncfn = "../prog03_calc_rte/out-dwn1e1/Venus_VIRA+GasVMR+CldMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc"
vname = "RadDwFlux"

gphys = GPhys::IO.open( ncfn, vname )

gphys = gphys.cut('Press'=>1e10)

def mkwlobj( gp )

  namelev = "WaveNum"
  wn = gp.coord(namelev)

  gp = gp.copy
  wl = 1.0/wn

  gp = gp / wl**2
  #  gp = gp * wl

  #  wl = wl.convert_units( Units['micron'] )
  wl.long_name = "wavelength"
  vawl = wl.convert_units( Units['micron'] )
  #  vawl = VArray.new( wl.val, { "long_name"=>'wavelength', "units"=>wl.units.to_s }, namelev )
  gp.axis(namelev).set_pos(vawl)

  gp.long_name = "flux"

  # conversion from Wm-2 m-1 to Wm-2 (micron)-1
  gp = gp * 1e-6
  #  gp.units = 'Wm|-2"(micron)|-1"'
#  gp.units = 'Wm|-2"('+DCL::csgi(163)+'m)|-1"'

  return gp
end

gphys = mkwlobj( gphys )

iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)


#DCL.sldiv('y',1,4)
DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.6)
DCL.sglset('LCLIP', true)
DCL.sglset('LCNTL', true)
GGraph.set_fig 'itr'=> 1, 'viewport'=>[0.25,0.7,0.15,0.6], 'window'=>[0.2,1.0,0.0,300]

GGraph.line gphys, true, 'exchange'=>false

DCL.grcls
