#!/usr/bin/ruby
require "numru/ggraph"
include NumRu

dir = "../../prog03_calc_rte/out_hitemp_dwn1e1/F2635.0_GQ02_all"
dir = "../out_hitemp_dwn1e1/F2635.0_GQ02_all"
sym = "Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2"


print "1: Display,  2: File\n"
citr = gets
citr = citr.chomp!
DCL.gropn(citr.to_i)
#DCL.gropn(1)

DCL.sldiv('y',3,1)
DCL.sgpset('lcntl',true)
DCL.sgpset('lfull',true)
DCL.uzfact(0.7)
DCL.sgpset('lfprop',true)
DCL.sglset('lclip',true)

svx1 = 0.10; svx2 = 0.4; svy1 = 0.15; svy2 = 0.9

itr = 2
y1 = 100.0e5; y2 = 0.0001e5

x1 = -17000; x2 = 17000
GGraph.set_fig 'itr'=>itr, 'viewport'=>[svx1,svx2,svy1,svy2], 'window'=>[x1,x2,y1,y2]

# flux log
#graph_flux( svx1, svx2, svy1, svy2, gpupfl, gpdnfl, true, false )

cwl = ['LW', 'SW']

for iwl in 0..(cwl.size-1)
  if iwl == 0 then
    flag_first = true
  else
    flag_first = false
  end

  fn = sym + "_Flux.nc"
  path = dir + "/" + fn
  vnameup = 'RadUwFlux'+cwl[iwl]
  gpupfl = GPhys::NetCDF_IO.open( path, vnameup )
  vnamedn = 'RadDwFlux'+cwl[iwl]
  gpdnfl = GPhys::NetCDF_IO.open( path, vnamedn )

  gpupflout = gpupfl.copy
  gpdnflout = gpdnfl.copy
  z = gpupflout.axis('Press').pos
  z.long_name = 'pressure'
  gpupflout.axis('Press').set_pos(z)
  z = gpdnflout.axis('Press').pos
  z.long_name = 'pressure'
  gpdnflout.axis('Press').set_pos(z)
  gpupflout =  gpupflout
  gpdnflout = -gpdnflout
  gpupflout.long_name = "flux"
  gpdnflout.long_name = "flux"
  gpupflout = gpupflout.cut('Press'=>y1..y2)
  gpdnflout = gpdnflout.cut('Press'=>y1..y2)

  GGraph.line gpupflout, flag_first, "exchange"=>true, "index"=>20, 'type'=>iwl+1, "title"=>"", 'legend_vx'=>0.12, 'legend'=>vnameup
  GGraph.line gpdnflout, false     , "exchange"=>true, "index"=>40, 'type'=>iwl+1, "title"=>"", 'legend_vx'=>0.12, 'legend'=>vnamedn

end


x1 = -40; x2 = 40
x1 = -200; x2 = 200
GGraph.set_fig 'itr'=>itr, 'viewport'=>[svx1,svx2,svy1,svy2], 'window'=>[x1,x2,y1,y2]

# flux log
#graph_flux( svx1, svx2, svy1, svy2, gpupfl, gpdnfl, true, false )

cwl = ['LW', 'SW']

for iwl in 0..(cwl.size-1)
  if iwl == 0 then
    flag_first = true
  else
    flag_first = false
  end

  fn = sym + "_Flux.nc"
  path = dir + "/" + fn
  vnameup = 'RadUwFlux'+cwl[iwl]
  gpupfl = GPhys::NetCDF_IO.open( path, vnameup )
  vnamedn = 'RadDwFlux'+cwl[iwl]
  gpdnfl = GPhys::NetCDF_IO.open( path, vnamedn )

  gpupflout = gpupfl.copy
  gpdnflout = gpdnfl.copy
  z = gpupflout.axis('Press').pos
  z.long_name = 'pressure'
  gpupflout.axis('Press').set_pos(z)
  z = gpdnflout.axis('Press').pos
  z.long_name = 'pressure'
  gpdnflout.axis('Press').set_pos(z)
  gpupflout =  gpupflout
  gpdnflout = -gpdnflout
  gpupflout.long_name = "net flux"
  gpdnflout.long_name = "net flux"
  gpupflout = gpupflout.cut('Press'=>y1..y2)
  gpdnflout = gpdnflout.cut('Press'=>y1..y2)

  GGraph.line gpupflout+gpdnflout, flag_first, "exchange"=>true, "index"=>10, 'type'=>iwl+1, "title"=>"", 'legend_vx'=>0.12, 'legend'=>"RadNetFlux"+cwl[iwl]

end


# tendency log
#graph_tendency( svx1, svx2, svy1, svy2, gptend, true, false )

x1 = -0.01; x2 = 0.01
x1 = -1e-1; x2 = 1e-1
x1 = -1e1; x2 = 1e1
GGraph.set_fig 'itr'=>itr, 'viewport'=>[svx1,svx2,svy1,svy2], 'window'=>[x1,x2,y1,y2]

for iwl in 0..(cwl.size-1)
  if iwl == 0 then
    flag_first = true
  else
    flag_first = false
  end

  fn = sym + "_Tendency.nc"
  path = dir + "/" + fn
  vname = 'DTempDt'+cwl[iwl]
  gp = GPhys::NetCDF_IO.open( path, vname )

  gpout = gp.copy
  z = gpout.axis('Press').pos
  z.long_name = 'pressure'
  gpout.axis('Press').set_pos(z)
  gpout = gpout * 86400.0
  gpout.units = 'K (day)|-1"'
  gpout.long_name = "tendency"

  GGraph.line gpout, flag_first , "exchange"=>true, "type"=>iwl+1, "title"=>"", 'legend_vx'=>0.12, 'legend'=>vname

#  if flag_first then
#    gptot = gpout.copy
#  else
#    gpout.units = 'K (day)-1'
#    gptot = gptot + gpout.copy.val
#  end
end
#gpout = gptot
#GGraph.line gpout, false , "exchange"=>true, "type"=>iwl+1, "title"=>"", 'legend_vx'=>0.12, 'legend'=>'DTempDt'

DCL.grcls
