program main

  use vtype_module
  use fi_module


  use constants0, only : PI

  use rad_planetconst, only : &
    & RadPlanetConstInit, &
    & Grav,            &
    & Cp,              &
    & MolWtNonRadAct

  use sortac_module, only : sortac

  use rad_flux, only : RadFluxCalcFlux, RadFluxInit, RadFluxFinalize, RadFluxOutputInit, RadFluxOutputFinalize

  use rad_output, only : RadOutputFluxTendency

  use rad_kd_utils, only : RadKDUtilsCalcTendency

  use hitranconst, only : m_HITRANMolWt

  use io_profile, only : &
    & IOProfileInqDimLen, &
    & IOProfileRead, &
    & IOProfileReadPtcl

  implicit none


  character(stdstr) :: CtlFN0 = 'planetconst.conf'
  real(DP)          :: GravSet
  real(DP)          :: CpSet
  real(DP)          :: MolWtNonRadActSet

  character(128) :: CtlFN  = 'sort_ac.conf'
  character(128) :: CtlFN2 = 'sort_ac_file.conf'
  character(128) :: CtlFN3 = 'calc_rte.conf'

  integer :: FileUnit
  integer :: FileUnitQL
  integer :: iostat

  integer           :: InNcID
  character(stdstr) :: Mode


  logical :: FlagChkConstVMR
  logical :: FlagKeyMolACAverage
  logical :: FlagNonKeyMolACAverage
  logical :: FlagPFRatioOne
  logical :: FlagSortPFRatioAverage

  integer, parameter :: MaxNmlArySize = 256
  real(8)            :: WNBnds(MaxNmlArySize)
  integer            :: BandNBin(MaxNmlArySize)
  integer            :: KeyMolNum(MaxNmlArySize)

  integer              :: NKeyMol
  integer, allocatable :: a_KeyMolNum      (:)

  integer              :: NBand
  real(8), allocatable :: a_BandWNBnds     (:)
  integer, allocatable :: a_BandNBin       (:)
  integer, allocatable :: ab_BandKeyMolNum (:,:)

  integer              :: NBandCur = 1
  real(8), allocatable :: a_BandCurWNBnds     (:)
  integer, allocatable :: a_BandCurNBin       (:)
  integer, allocatable :: ab_BandCurKeyMolNum (:,:)

  integer :: n


  ! 設定変数, 他
  ! setteing parameter, values
  !
  character(256) :: InOrgOptPropNcFN
                          ! 
                          ! input file name for original optical properties
  character(256) :: InOrgStrSpeNcFN
  character(256) :: InLBLPtclOptPropCoefNcFN = ''
  character(256) :: InBandAvePtclOptPropCoefNcFN = ''
  character(256) :: InPtclOptPropCoefNcFN

  logical        :: FlagOutSpeFlux
  character(256) :: OutSpeFluxNcFN
  character(256) :: OutOptPropNcFN
  character(256) :: OutFluxNcFN
  character(256) :: OutTendencyNcFN

  character(256) :: InProfNcFn

!!$  real(8) :: CentStarConst

!!$  real(8) :: InAngle
                          ! sec (太陽光入射角) [1]
                          ! sec (angle of incidence) [1]
!!$  real(8) :: SurfAlbedo
                          ! 地表面アルベド [1]
                          ! surface albedo [1]

  integer, allocatable :: m_MolNum(:)
  real(8), allocatable :: r_Press (:)
  real(8), allocatable :: r_Temp  (:)
  real(8), allocatable :: rm_VMR  (:,:)

  integer                            :: NPtcl
  integer              , allocatable :: a_PtclNum    (:)
  character(len=stdstr), allocatable :: a_PtclName   (:)
  real(8)              , allocatable :: a_PtclDens   (:)
  real(8)              , allocatable :: za_PtclEffRad(:,:)
  real(8)              , allocatable :: za_PtclMMR   (:,:)
  real(8)              , allocatable :: za_DelPtclNum(:,:)

  real(DP)              :: StrFluxTOA

  real(DP) :: AlbedoSW
  real(DP) :: AlbedoLW
  real(DP) :: WaveNumAlbedoSwitch

  integer  :: NGQ
  real(DP) :: SZADeg
  character(128) :: StrSpeNcFN

  real(DP) :: WNIntegStart
  real(DP) :: WNIntegEnd
  real(DP) :: WNIntegStartSave
  real(DP) :: WNIntegEndSave

  real(8), allocatable :: r_MeanMolWt(:)
  real(8), allocatable :: r_VMRNonRadAct(:)

  real(8), allocatable :: z_Press(:)
  real(8)              :: SurfTemp


  real(8), allocatable :: r_RadUwFluxBandLBL(:)
                          ! upward flux
  real(8), allocatable :: r_RadDwFluxBandLBL(:)
                          ! downward flux

  real(8), allocatable :: z_DTempDt      (:)
                          ! tendency
  real(8), allocatable :: r_RadUwFlux    (:)
                          ! upward flux
  real(8), allocatable :: r_RadDwFlux    (:)
                          ! downward flux
  real(DP), allocatable :: ra_DelRadUwFlux(:,:)
  real(DP), allocatable :: ra_DelRadDwFlux(:,:)

  real(DP), allocatable :: r_RadUwFluxLW    (:)
  real(DP), allocatable :: r_RadDwFluxLW    (:)
  real(DP), allocatable :: r_RadUwFluxSW    (:)
  real(DP), allocatable :: r_RadDwFluxSW    (:)
  real(DP), allocatable :: ra_DelRadUwFluxLW(:,:)
  real(DP), allocatable :: ra_DelRadDwFluxLW(:,:)
  real(DP), allocatable :: ra_DelRadUwFluxSW(:,:)
  real(DP), allocatable :: ra_DelRadDwFluxSW(:,:)

  real(8) :: RadUwFluxErrMax
  real(8) :: RadDwFluxErrMax
  real(8) :: RadUwFluxRatioMax
  real(8) :: RadDwFluxRatioMax
  real(8) :: RadNetFluxErrMax

  character(128) :: InNcFN
  character(128) :: InStrSpeNcFN
  character(128) :: OutNcFN
  character(128) :: OutNcFN1
  character(128) :: OutNcFN2

  integer :: kmax
  integer :: NMol

  logical :: FlagSort
  logical :: FlagBinning
  logical :: FlagBinningDemonstration
  logical :: FlagCorrelation
  logical :: FlagKeyMolAbsOverlap

  integer              :: NGaussReg
  real(8), allocatable :: a_GaussRegBnds(:)
  real(8)              :: GaussRegBnds(MaxNmlArySize)


  real(DP)       :: PressForPFSort

  character(128) :: Method

  integer :: iMode
  integer :: iBand

  integer :: iBands
  integer :: iBande
  integer :: iModes
  integer :: iModee

  integer :: k
  integer :: m
  integer :: iKeyMol



  namelist /planetconst_nml/ &
    & GravSet, CpSet, MolWtNonRadActSet
  namelist /band_mode_nml/ &
    & iBands, iBande, iModes, iModee
  namelist /flag_nml/ &
!!$    & FlagChkConstH2OMR, FlagKeyMolACAverage, FlagNonKeyMolACAverage
!!$    & FlagChkConstH2OMR
    & FlagChkConstVMR
  namelist /sort_file_nml/ &
    & InProfNcFn, &
!!$    & InNcFN, OutNcFN
    & InOrgOptPropNcFN, &
    & InOrgStrSpeNcFN, &
    & FlagOutSpeFlux,  &
    & OutSpeFluxNcFN,  &
    & OutFluxNcFN,     &
    & OutTendencyNcFN, &
    & OutOptPropNcFN
  namelist /band_nml/ &
    & NBand, WNBnds, BandNBin, KeyMolNum
  namelist /rte_nml/ &
    & StrFluxTOA, &
    & StrSpeNcFN, &
    & AlbedoSW, &
    & AlbedoLW, &
    & WaveNumAlbedoSwitch, &
    & NGQ, &
    & SZADeg, &
    & WNIntegStart, &
    & WNIntegEnd

  namelist /gauss_region_nml/ &
    & NGaussReg, GaussRegBnds

  WNIntegStart = -1.0d0
  WNIntegEnd   = -1.0d0

!!$  StrFluxTOA = 1370.0d0
  StrFluxTOA =    0.0d0
  StrSpeNcFN = 'solarflux.nc'
  AlbedoSW   = 0.2d0
  AlbedoLW   = 0.0d0
  WaveNumAlbedoSwitch = 3250.0d2
  SZADeg     =    0.0d0

  NGQ = 1
  write( 6, * ) '**********************'
  write( 6, * ) '**********************'
  write( 6, * ) '**********************'
  write( 6, * ) 'NOTE: NGQ is not used.'
  write( 6, * ) '**********************'
  write( 6, * ) '**********************'
  write( 6, * ) '**********************'


  InProfNcFn = ''

  InOrgStrSpeNcFN = "strspe.nc"

  FlagChkConstVMR      = .true.

  InNcFN  = ''
  OutOptPropNcFN = ''

  NBand = 1
  WNBnds    = -999.0d0
  WNBnds(1) = 0.0d0
  WNBnds(2) = 1.0d100
  KeyMolNum    = -1
  KeyMolNum(1) = 1
  BandNBin     = -1
  BandNBin(1)  = 10

  GaussRegBnds = 0.0d0


  ! Read a namelist file

  call fi_open( CtlFN0, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = planetconst_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist, planetconst_nml, is something wrong.'
  end if
  write( 6, nml = planetconst_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_mode_nml, iostat = iostat )
  write( 6, * ) iostat
  if ( iostat /= 0 ) then
    stop 'Namelist band_mode_nml is something wrong.'
  end if
  write( 6, nml = band_mode_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = flag_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist flag_nml is something wrong.'
  end if
  write( 6, nml = flag_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist band_nml is something wrong.'
  end if
  write( 6, nml = band_nml )
  !
  rewind( FileUnit )
  read( FileUnit, nml = gauss_region_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist gauss_region_nml is something wrong.'
  end if
  write( 6, nml = gauss_region_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN2, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = sort_file_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist sort_file_nml is something wrong.'
  end if
  write( 6, nml = sort_file_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN3, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = rte_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist rte_nml is something wrong.'
  end if
  write( 6, nml = rte_nml )
  !
  close( FileUnit )


  ! Initialize planetary constants
  !
  call RadPlanetConstInit( &
    & GravSet           = GravSet,           &
    & CpSet             = CpSet,             &
    & MolWtNonRadActSet = MolWtNonRadActSet  &
    & )


  allocate( a_GaussRegBnds(0:NGaussReg) )
  a_GaussRegBnds = GaussRegBnds(1:NGaussReg+1)
  ! check
  if ( NGaussReg <= 0 ) then
    write( 6, * ) "NGaussReg is not appropriate: ", NGaussReg
    stop
  end if
  if ( ( a_GaussRegBnds(0) /= 0.0d0 ) .or. ( a_GaussRegBnds(NGaussReg) /= 1.0d0 ) ) then
    write( 6, * ) "GaussRegBnds is not appropriate: ", a_GaussRegBnds
    stop
  end if

  WNIntegStartSave = WNIntegStart
  WNIntegEndSave   = WNIntegEnd



!!$  Mode = "read"
!!$  call ni3_open( InProfNcFN, Mode, InNcID )
!!$  call ni3_inq_dimlen( InNcID, "Press" , kmax )
!!$  kmax = kmax - 1
!!$  call ni3_inq_dimlen( InNcID, "MolNum", NMol )
!!$  allocate( m_MolNum   (1:NMol) )
!!$  allocate( r_Press    (0:kmax) )
!!$  allocate( r_Temp     (0:kmax) )
!!$  allocate( rm_VMR     (0:kmax,NMol) )
!!$  call ni3_get_var( InNcID, "MolNum", m_MolNum )
!!$  call ni3_get_var( InNcID, "Press" , r_Press  )
!!$  call ni3_get_var( InNcID, "Temp"  , r_Temp   )
!!$  call ni3_get_var( InNcID, "VMR"   , rm_VMR   )
!!$  call ni3_get_var( InNcID, 'Ts'    , SurfTemp )
!!$  call ni3_close( InNcID )

  call IOProfileInqDimLen(      &
    & InProfNcFN, "Press", &
    & kmax &
    & )
  kmax = kmax - 1
  call IOProfileInqDimLen(      &
    & InProfNcFN, "MolNum", &
    & NMol &
    & )
  allocate( m_MolNum   (1:NMol) )
  allocate( r_Press    (0:kmax) )
  allocate( r_Temp     (0:kmax) )
  allocate( rm_VMR     (0:kmax,NMol) )
  call IOProfileRead(      &
    & InProfNcFN, "Press", "MolNum", "Temp", "Ts", "VMR", &
    & kmax+1, NMol, &
    & r_Press, m_MolNum, r_Temp, SurfTemp, rm_VMR    &
    & )


  allocate( r_MeanMolWt(0:kmax) )

!!$  r_MeanMolWt = MeanMolWt

  allocate( r_VMRNonRadAct(0:kmax) )
  r_VMRNonRadAct = 1.0d0
  do m = 1, NMol
    r_VMRNonRadAct = r_VMRNonRadAct - rm_VMR(:,m)
  end do
  r_MeanMolWt = 0.0d0
  r_MeanMolWt = r_MeanMolWt + r_VMRNonRadAct * MolWtNonRadAct
  do m = 1, NMol
    r_MeanMolWt = r_MeanMolWt + rm_VMR(:,m) * m_HITRANMolWt(m_MolNum(m))
  end do
  deallocate( r_VMRNonRadAct )
  write( 6, * ) 'Mean molecular weight'
  do k = 0, kmax
    write( 6, * ) k, r_MeanMolWt(k)
  end do



  ! temporarily set
!!$  NPtcl              = 2
!!$  allocate( a_PtclName(NPtcl) )
!!$  allocate( za_PtclEffRad(kmax,NPtcl) )
!!$  allocate( za_DelPtclNum(kmax,NPtcl) )
!!$  a_PtclName(1)      = "H2OLiq"
!!$  a_PtclName(2)      = "H2OSol"
!!$  za_PtclEffRad(:,1) = 10.0d-6
!!$  za_PtclEffRad(:,2) = 50.0d-6
!!$  za_DelPtclNum      = 0.0d0
  !
  NPtcl              = 0
  allocate( a_PtclName(NPtcl) )
  allocate( za_PtclEffRad(kmax,NPtcl) )
  allocate( za_DelPtclNum(kmax,NPtcl) )
  a_PtclName    = ""
  za_PtclEffRad = 0.0d0
  za_DelPtclNum = 0.0d0
  allocate( z_Press   (1:kmax) )


!!$  call IOProfileInqDimLen(      &
!!$    & InProfNcFN, "PtclNum", &
!!$    & NPtcl &
!!$    & )
!!$  !
!!$  allocate( z_Press   (1:kmax) )
!!$  allocate( a_PtclNum (NPtcl) )
!!$  allocate( a_PtclName(NPtcl) )
!!$  allocate( a_PtclDens(NPtcl) )
!!$  allocate( za_PtclEffRad(kmax,NPtcl) )
!!$  allocate( za_PtclMMR   (kmax,NPtcl) )
!!$  allocate( za_DelPtclNum(kmax,NPtcl) )
!!$  !
!!$  write( 6, * ) NPtcl
!!$  if ( NPtcl > 0 ) then
!!$    call IOProfileReadPtcl(      &
!!$      & InProfNcFN, &
!!$      & kmax, NPtcl, &
!!$      & z_Press, a_PtclNum, a_PtclName, a_PtclDens, za_PtclEffRad, za_PtclMMR  &
!!$
!!$      & )
!!$    do m = 1, NPtcl
!!$      do k = 1, kmax
!!$        za_DelPtclNum(k,m) = za_PtclMMR(k,m) &
!!$          & * ( r_Press(k-1) - r_Press(k) ) / Grav &
!!$          & / ( 4.0d0 / 3.0d0 * PI * za_PtclEffRad(k,m)**3 * a_PtclDens(m) )
!!$      end do
!!$    end do
!!$  end if


  do n = 1, MaxNmlArySize
    if ( KeyMolNum(n) < 0 ) then
      exit
    end if
  end do
  NKeyMol = n - 1
  allocate( a_KeyMolNum(1:NKeyMol) )
  a_KeyMolNum(1:NKeyMol) = KeyMolNum(1:NKeyMol)


  allocate( z_DTempDt  (1:kmax) )
  allocate( r_RadUwFlux(0:kmax) )
  allocate( r_RadDwFlux(0:kmax) )
  allocate( ra_DelRadUwFlux(0:kmax,-1:1) )
  allocate( ra_DelRadDwFlux(0:kmax,-1:1) )

  allocate( r_RadUwFluxLW    (0:kmax) )
  allocate( r_RadDwFluxLW    (0:kmax) )
  allocate( r_RadUwFluxSW    (0:kmax) )
  allocate( r_RadDwFluxSW    (0:kmax) )
  allocate( ra_DelRadUwFluxLW(0:kmax,-1:1) )
  allocate( ra_DelRadDwFluxLW(0:kmax,-1:1) )
  allocate( ra_DelRadUwFluxSW(0:kmax,-1:1) )
  allocate( ra_DelRadDwFluxSW(0:kmax,-1:1) )

  do k = 1, kmax
    z_Press(k) = ( r_Press(k-1) + r_Press(k) ) / 2.0d0
  end do


  WNIntegStart = WNIntegStartSave
  WNIntegEnd   = WNIntegEndSave

  Method = 'LBL'
  call RadFluxInit( &
    & Grav, &
    & WaveNumAlbedoSwitch, &
    & InOrgOptPropNcFN, InLBLPtclOptPropCoefNcFN, &
!!$    & InOrgStrSpeNcFN, &
    & StrSpeNcFN, &
    & Method &
    & )
  if ( FlagOutSpeFlux ) then
    call RadFluxOutputInit( &
      & InOrgOptPropNcFN, &
      & OutSpeFluxNcFN, &
      & kmax, r_Press &
      & )
  end if
  call RadFluxCalcFlux( &
    & kmax, NMol, &
    & m_MolNum, &
    & r_Press, &
    & SurfTemp, r_Temp, rm_VMR, &
    & NPtcl, a_PtclName, za_PtclEffRad, za_DelPtclNum, &
    & AlbedoSW, AlbedoLW, SZADeg, &
    & StrFluxTOA, &
    & r_MeanMolWt, &
    & r_RadUwFlux, r_RadDwFlux, &
    & ra_DelRadUwFlux, ra_DelRadDwFlux, &
    & r_RadUwFluxLW, r_RadDwFluxLW, &
    & r_RadUwFluxSW, r_RadDwFluxSW, &
    & ra_DelRadUwFluxLW, ra_DelRadDwFluxLW, &
    & ra_DelRadUwFluxSW, ra_DelRadDwFluxSW, &
    & WNIntegStart, WNIntegEnd &
    & )
  if ( FlagOutSpeFlux ) then
    call RadFluxOutputFinalize
  end if
  call RadFluxFinalize

  call RadKDUtilsCalcTendency( &
    & Grav, Cp, &
    & kmax, r_Press, &
    & r_RadUwFlux, r_RadDwFlux, &
    & z_DTempDt &
    & )
  call RadOutputFluxTendency( &
    & OutFluxNcFN, OutTendencyNcFN,   &
    & kmax, r_Press, z_Press, &
    & r_RadUwFlux, r_RadDwFlux, z_DTempDt &
    & )



  InNcFN = InOrgOptPropNcFN



  !TESTTESTTESTTESTTESTTESTTESTTESTTESTTEST
!!$  NBand = 3000.0d2 / 100.0d2
!!$  do n = 1, NBand+1
!!$    WNBnds(n) = 100.0d2 * (n-1)
!!$  end do
!!$  BandNBin = 10
!!$  KeyMolNum = 1
  !TESTTESTTESTTESTTESTTESTTESTTESTTESTTEST



  if ( NBand+1 > MaxNmlArySize ) then
    stop 'Array size is too large.'
  end if
  do n = 1, NBand
    if ( WNBnds(n) > WNBnds(n+1) ) then
      stop 'Band bounds does not increase monotonicaly.'
    end if
  end do


!!$  RatioSolarConst = SolConst/(StB*SolTemp*SolTemp*SolTemp*SolTemp)


  allocate( a_BandWNBnds     (0:NBand) )
  allocate( a_BandNBin       (1:NBand) )
  allocate( ab_BandKeyMolNum (1:NKeyMol,1:NBand) )

  a_BandWNBnds   (0:NBand) = WNBnds   (1:NBand+1)
  a_BandNBin     (1:NBand) = BandNBin (1:NBand  )

  do n = 1, NBand
    ab_BandKeyMolNum(:,n) = a_KeyMolNum
  end do


  ! check
  do iBand = 1, NBand
    if ( a_BandNBin(iBand) < 0 ) then
      write( 6, * ) 'BandNBin is negative at ', iBand
      stop
    end if
  end do
  do iBand = 1+1, NBand
    do iKeyMol = 1, NKeyMol
      if ( ab_BandKeyMolNum(iKeyMol,iBand) /= ab_BandKeyMolNum(iKeyMol,1) ) then
        write( 6, * ) 'Now, KeyMolNum has to be the same for all bands.'
        write( 6, * ) ab_BandKeyMolNum
        stop
      end if
    end do
  end do


  allocate( r_RadUwFluxBandLBL(0:kmax) )
  allocate( r_RadDwFluxBandLBL(0:kmax) )


  PressForPFSort = r_Press(0)


  call fi_open( "QuickLook.data", "write", FileUnitQL )

  do iBand = max( iBands, 0 ), min( iBande, NBand+1 )
!!$  do iBand = 1, NBand+1
!!$  do iBand = NBand+1, NBand+1
!!$  do iBand = 0, 0
!!$  do iBand = 1, 1
!!$  do iBand = 4, 4
!!$  do iBand = 10, 10

!!$    if ( iBand == 0 ) then
    if ( ( iBand == 0 ) .or. ( iBand == NBand+1 ) ) then
      NBandCur = NBand
      allocate( a_BandCurWNBnds     (0:NBandCur) )
      allocate( a_BandCurNBin       (1:NBandCur) )

      a_BandCurWNBnds   (0:NBandCur) = a_BandWNBnds   (0:NBandCur)
      a_BandCurNBin     (1:NBandCur) = a_BandNBin     (1:NBandCur)

      allocate( ab_BandCurKeyMolNum (1:NKeyMol,1:NBandCur) )
      ab_BandCurKeyMolNum(:,1:NBandCur) = ab_BandKeyMolNum(:,1:NBandCur)

      WNIntegStart = WNIntegStartSave
      WNIntegEnd   = WNIntegEndSave
    else
      NBandCur = 1
      allocate( a_BandCurWNBnds  (0:NBandCur) )
      allocate( a_BandCurNBin    (1:NBandCur) )

      a_BandCurWNBnds   (0:NBandCur) = a_BandWNBnds   (iBand-1:iBand)
      a_BandCurNBin     (1:NBandCur) = a_BandNBin     (iBand  :iBand)

      allocate( ab_BandCurKeyMolNum (1:NKeyMol,1:NBandCur) )
      ab_BandCurKeyMolNum(:,1:NBandCur) = ab_BandKeyMolNum(:,iBand:iBand)

      WNIntegStart = a_BandCurWNBnds(0       )
      WNIntegEnd   = a_BandCurWNBnds(NBandCur)
    end if



    call RadFluxInit( &
      & Grav, &
      & WaveNumAlbedoSwitch, &
      & InOrgOptPropNcFN, InLBLPtclOptPropCoefNcFN, &
!!$      & InOrgStrSpeNcFN, &
      & StrSpeNcFN, &
      & "LBL" &
      & )
    call RadFluxCalcFlux( &
      & kmax, NMol, &
      & m_MolNum, &
      & r_Press, &
      & SurfTemp, r_Temp, rm_VMR, &
      & NPtcl, a_PtclName, za_PtclEffRad, za_DelPtclNum, &
      & AlbedoSW, AlbedoLW, SZADeg, &
      & StrFluxTOA, &
      & r_MeanMolWt, &
      & r_RadUwFlux, r_RadDwFlux, &
      & ra_DelRadUwFlux, ra_DelRadDwFlux, &
      & r_RadUwFluxLW, r_RadDwFluxLW, &
      & r_RadUwFluxSW, r_RadDwFluxSW, &
      & ra_DelRadUwFluxLW, ra_DelRadDwFluxLW, &
      & ra_DelRadUwFluxSW, ra_DelRadDwFluxSW, &
!!$      & a_BandCurWNBnds(0), a_BandCurWNBnds(NBandCur) &
      & WNIntegStart, WNIntegEnd &
      & )
    call RadFluxFinalize

    r_RadUwFluxBandLBL = r_RadUwFlux
    r_RadDwFluxBandLBL = r_RadDwFlux



    do iMode = iModes, iModee
!!$    do iLoop = 0, 0
!!$    do iLoop = 0, 1
!!$    do iLoop = 0, 3
!!$    do iLoop = 0, 4
!!$    do iLoop = 0, 5
!!$    do iLoop = 0, 6
!!$    do iLoop = 0, 7
!!$    do iLoop = 0, 9
!!$    do iLoop = 1, 1
!!$    do iLoop = 2, 2
!!$    do iLoop = 3, 3
!!$    do iLoop = 4, 4
!!$    do iLoop = 5, 5
!!$    do iLoop = 6, 6
!!$    do iLoop = 7, 7
!!$    do iLoop = 7, 9
!!$    do iLoop = 8, 9
      write( 6, * ) 'iBand = ', iBand
      write( 6, * ) 'iMode = ', iMode


      select case ( iMode )
      case ( 0 )
        FlagSort                 = .false.
        Method                   = 'LBL'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InLBLPtclOptPropCoefNcFN
      case ( 1 )
        FlagSort                 = .false.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = ''
      case ( 2 )
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = ''
      case ( 3 )
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = ''
      case ( 4 ) ! test for constant Planck function in each band
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .false.
        FlagPFRatioOne           = .true.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = ''
      case ( 5 ) ! test for correlation
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = ''
      case ( 6 )
        FlagSort                 = .true.
        Method                   = 'LBLConstPF'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .true.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = ''
      case ( 7 ) ! the "best" with correlation before binning (2016/12/14)
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .false.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InBandAvePtclOptPropCoefNcFN
      case ( 8 ) ! the "best" with correlation and bin-averaged PF before binning (2017/04/18)
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InBandAvePtclOptPropCoefNcFN
      case ( 9 ) ! for demonstration
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .true.
        FlagBinningDemonstration = .true.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InBandAvePtclOptPropCoefNcFN
      case ( 10 ) ! the "best" with correlation and binning (2016/12/16)
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .true.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .true.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InBandAvePtclOptPropCoefNcFN
      case ( 11 ) ! for demonstration for non-correlation
        FlagSort                 = .true.
        Method                   = 'KDDevelop'
        FlagCorrelation          = .false.
        FlagKeyMolAbsOverlap     = .true.
        FlagPFRatioOne           = .false.
        FlagSortPFRatioAverage   = .true.
        FlagBinning              = .false.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InBandAvePtclOptPropCoefNcFN
      case ( 12 )
        FlagSort               = .true.
        Method                 = 'KDDevelop'
        FlagCorrelation        = .true.
        FlagKeyMolAbsOverlap   = .true.
        FlagPFRatioOne         = .false.
        FlagSortPFRatioAverage = .false.
        FlagBinning            = .true.
        FlagBinningDemonstration = .false.
        FlagKeyMolACAverage      = .false.
        FlagNonKeyMolACAverage   = .true.
        InPtclOptPropCoefNcFN    = InBandAvePtclOptPropCoefNcFN
      case default
        stop 'Unexpected value of iMode'
      end select

      write( 6, * ) "KeyMolNum                : "
      do n = 1, NBandCur
        write( 6, * ) "  Band: ", n, " : ", &
          & ( ab_BandCurKeyMolNum(iKeyMol,n), iKeyMol = 1, NKeyMol )
      end do
      write( 6, * ) "FlagSort                 : ", FlagSort
      write( 6, * ) "Method                   : ", trim( Method )
      write( 6, * ) "FlagCorrelation          : ", FlagCorrelation
      write( 6, * ) "FlagKeyMolAbsOverlap     : ", FlagKeyMolAbsOverlap
      write( 6, * ) "FlagPFRatioOne           : ", FlagPFRatioOne
      write( 6, * ) "FlagSortPFRatioAverage   : ", FlagSortPFRatioAverage
      write( 6, * ) "FlagBinning              : ", FlagBinning
      write( 6, * ) "FlagBinningDemonstration : ", FlagBinningDemonstration
      write( 6, * ) "FlagKeyMolACAverage      : ", FlagKeyMolACAverage
      write( 6, * ) "FlagNonKeyMolACAverage   : ", FlagNonKeyMolACAverage

      InNcFN       = InOrgOptPropNcFN
      InStrSpeNcFN = InOrgStrSpeNcFN
      write( OutNcFN, '(a,a,i2.2,a,i2.2,a)' ) &
        & OutOptPropNcFN(1:len_trim(OutOptPropNcFN)-3), '-', iband, '-', iMode, '.nc'
      call sortac( &
        & FlagSort, &
!        & InNcFN, OutNcFN, &
        & InNcFN, InProfNcFN, OutNcFN, &
        & FlagChkConstVMR, FlagBinning, FlagBinningDemonstration, &
        & FlagKeyMolACAverage, FlagNonKeyMolACAverage, &
        & FlagPFRatioOne, &
        & FlagSortPFRatioAverage, &
!        & NBand, a_BandWNBnds, a_BandKeyMolNum, a_BandNBin &
        & FlagCorrelation, &
        & FlagKeyMolAbsOverlap, &
        & InStrSpeNcFN, &
        & NBandCur, a_BandCurWNBnds, a_BandCurNBin, &
        & NKeyMol, ab_BandCurKeyMolNum, &
        & NGaussReg, a_GaussRegBnds, &
        & PressForPFSort &
        & )

      InNcFN = OutNcFN
      select case ( iMode )
      case ( 0 )
        InStrSpeNcFN = InOrgStrSpeNcFN
      case default
        InStrSpeNcFN = OutNcFN
      end select
      !
      call RadFluxInit( &
        & Grav, &
        & WaveNumAlbedoSwitch, &
        & InNcFN, InPtclOptPropCoefNcFN, &
        & InStrSpeNcFN, &
!!$        & StrSpeNcFN, &
        & Method, &
        & a_BandCurWNBnds &
        & )
      call RadFluxCalcFlux( &
        & kmax, NMol, &
        & m_MolNum, &
        & r_Press, &
        & SurfTemp, r_Temp, rm_VMR, &
        & NPtcl, a_PtclName, za_PtclEffRad, za_DelPtclNum, &
        & AlbedoSW, AlbedoLW, SZADeg, &
        & StrFluxTOA, &
        & r_MeanMolWt, &
        & r_RadUwFlux, r_RadDwFlux, &
        & ra_DelRadUwFlux, ra_DelRadDwFlux, &
        & r_RadUwFluxLW, r_RadDwFluxLW, &
        & r_RadUwFluxSW, r_RadDwFluxSW, &
        & ra_DelRadUwFluxLW, ra_DelRadDwFluxLW, &
        & ra_DelRadUwFluxSW, ra_DelRadDwFluxSW, &
!!$        & a_BandCurWNBnds(0), a_BandCurWNBnds(NBandCur) &
        & WNIntegStart, WNIntegEnd &
        & )
      call RadFluxFinalize


      write( OutNcFN1, '(a,a,i2.2,a,i2.2,a)' ) &
        & OutFluxNcFN(1:len_trim(OutFluxNcFN)-3), '-', iband, '-', iMode, '.nc'
      write( OutNcFN2, '(a,a,i2.2,a,i2.2,a)' ) &
        & OutTendencyNcFN(1:len_trim(OutTendencyNcFN)-3), '-', iband, '-', iMode, '.nc'
      call RadKDUtilsCalcTendency( &
        & Grav, Cp, &
        & kmax, r_Press, &
        & r_RadUwFlux, r_RadDwFlux, &
        & z_DTempDt &
        & )
      call RadOutputFluxTendency( &
        & OutNcFN1, OutNcFN2,   &
        & kmax, r_Press, z_Press, &
        & r_RadUwFlux, r_RadDwFlux, z_DTempDt &
        & )


      RadUwFluxErrMax = 0.0d0
      RadDwFluxErrMax = 0.0d0
      do k = kmax, 0, -1
        RadUwFluxErrMax = &
          & max( RadUwFluxErrMax, &
          &   abs( ( r_RadUwFlux(k) - r_RadUwFluxBandLBL(k) ) / r_RadUwFluxBandLBL(k) ) )
        RadDwFluxErrMax = &
          & max( RadDwFluxErrMax, &
          &   abs( ( r_RadDwFlux(k) - r_RadDwFluxBandLBL(k) ) / ( r_RadDwFluxBandLBL(k) + 1.0d-10 ) ) )
      end do

      RadNetFluxErrMax = 0.0d0
      do k = kmax, 0, -1
        if ( ( r_RadUwFluxBandLBL(k) - r_RadDwFluxBandLBL(k) ) /= 0.0d0 ) then
          RadNetFluxErrMax = &
            & max( RadNetFluxErrMax, &
            &   abs( ( ( r_RadUwFlux(k) - r_RadDwFlux(k) ) &
            &        - ( r_RadUwFluxBandLBL(k) - r_RadDwFluxBandLBL(k) ) ) &
            &        / ( r_RadUwFluxBandLBL(k) - r_RadDwFluxBandLBL(k) ) ) )
        end if
      end do

      RadUwFluxRatioMax = 0.0d0
      RadDwFluxRatioMax = 0.0d0
      do k = kmax, 0, -1
        RadUwFluxRatioMax = &
          & max( RadUwFluxRatioMax, &
          &   abs( r_RadUwFlux(k) / r_RadUwFluxBandLBL(k) ) )
        RadDwFluxRatioMax = &
          & max( RadDwFluxRatioMax, &
          &   abs( r_RadDwFlux(k) / ( r_RadDwFluxBandLBL(k) + 1.0d-10 ) ) )
      end do

      write( 6, * ) iBand, iMode, a_BandCurWnBnds(0), '||', &
        & RadNetFluxErrMax, '|', RadDwFluxErrMax, RadDwFluxRatioMax, '|', RadUwFluxErrMax, RadUwFluxRatioMax
      write( FileUnitQL, * ) iBand, iMode, int(a_BandCurWnBnds(0)), int(a_BandCurWnBnds(NBandCur)), '||', &
        & RadNetFluxErrMax, '|', RadDwFluxErrMax, RadDwFluxRatioMax, '|', RadUwFluxErrMax, RadUwFluxRatioMax
      call flush( FileUnitQL )


    end do


    deallocate( a_BandCurWNBnds      )
    deallocate( a_BandCurNBin        )
    deallocate( ab_BandCurKeyMolNum  )

  end do

  close( FileUnitQL )

  deallocate( z_DTempDt   )
  deallocate( r_RadUwFlux )
  deallocate( r_RadDwFlux )
  deallocate( ra_DelRadUwFlux )
  deallocate( ra_DelRadDwFlux )

  deallocate( r_RadUwFluxLW     )
  deallocate( r_RadDwFluxLW     )
  deallocate( r_RadUwFluxSW     )
  deallocate( r_RadDwFluxSW     )
  deallocate( ra_DelRadUwFluxLW )
  deallocate( ra_DelRadDwFluxLW )
  deallocate( ra_DelRadUwFluxSW )
  deallocate( ra_DelRadDwFluxSW )

  deallocate( a_GaussRegBnds )

  deallocate( m_MolNum    )
  deallocate( r_Press     )
  deallocate( z_Press     )
  deallocate( r_Temp      )
  deallocate( rm_VMR      )
  deallocate( r_MeanMolWt )


  deallocate( a_BandWNBnds      )
  deallocate( a_BandNBin        )
  deallocate( ab_BandKeyMolNum  )

  deallocate( r_RadUwFluxBandLBL )
  deallocate( r_RadDwFluxBandLBL )


  write( 6, * ) "Finish"

end program main
