program main

  use vtype_module
  use constants0
  use fi_module
  use ni3_module

  use planck_func, only : PF

  implicit none


  character(128) :: CtlFN  = 'sort_ac.conf'
  character(128) :: CtlFN2 = 'sort_ac_atm.conf'
  character(128) :: CtlFN3 = 'sort_ac_file.conf'

  integer :: FileUnit
  integer :: iostat

  character(stdstr)              :: Mode
  integer                        :: NDims
  character(stdstr), allocatable :: a_DimNames( : )
  character(stdstr)              :: Name
  character(stdstr)              :: StdName
  character(extstr)              :: LongName
  character(stdstr)              :: Units
!!$  character(extstr)              :: Comment
  character(extstr*4)            :: CommentStrSpe

  integer, parameter     :: NBnd = 2
  integer                :: a_BndNum(NBnd)

  integer, parameter :: MaxNmlArySize = 256
  real(8)            :: WNBnds(MaxNmlArySize)
  integer            :: BandNBin(MaxNmlArySize)   ! This is not used.
  integer            :: KeyMolNum(MaxNmlArySize)  ! This is not used.

  integer              :: NBand
  integer, allocatable :: b_BandNum(:)
  real(8), allocatable :: b_BandWN (:)
  real(8), allocatable :: ab_BandWNBnds    (:,:)
  integer, allocatable :: ab_BandWNIndexBnds(:,:)

  real(8), allocatable :: w_StrSpe     (:)

  real(DP)             :: AtmTemp
  real(8), allocatable :: w_PF         (:)

  real(8), allocatable :: w_Weight     (:)


  real(8), allocatable :: w_RayScatCoefNonRadAct(:)
  real(8), allocatable :: wm_RayScatCoef(:,:)

  integer(i4b)                   :: NChar
  integer(i4b)     , allocatable :: a_CharNum(:)
  integer                        :: NParticle
  integer                        :: ParticleNRadiusMax
  integer          , allocatable :: a_ParticleNum      (:)
  integer          , allocatable :: r_ParticleRadiusNum(:)
  character(stdstr), allocatable :: a_ParticleName   (:)
  integer          , allocatable :: a_ParticleNRadius(:)
  real(8)          , allocatable :: ra_ParticleRadius(:,:)

  real(8)          , allocatable :: wra_QExt  (:,:,:)
  real(8)          , allocatable :: wra_SSA   (:,:,:)
  real(8)          , allocatable :: wra_AF    (:,:,:)


  real(8)          , allocatable :: b_BandAveRayScatCoefNonRadAct(:)
  real(8)          , allocatable :: bm_BandAveRayScatCoef(:,:)
  real(8)          , allocatable :: bra_BandAveQExt  (:,:,:)
  real(8)          , allocatable :: bra_BandAveSSA   (:,:,:)
  real(8)          , allocatable :: bra_BandAveAF    (:,:,:)


  character(stdstr) :: WaveNumAxisName

  character(128) :: PtclOptPropNcFN
  character(128) :: StrSpeNcFN

  integer              :: NWaveNum
  real(8), allocatable :: w_WaveNum(:)

  integer              :: NMolNum
  integer, allocatable :: m_MolNum(:)

  integer              :: TmpNum

  real(8) :: CommentDWN

!!$  real(8) :: Sum

  character(128) :: InNcFN
  character(128) :: OutNcFN

  integer :: InNcID
  integer :: InNcIDPtcl
  integer :: OutNcID

  integer :: i
  integer :: l
  integer :: m
  integer :: n




  namelist /file_nml/ &
    & StrSpeNcFN, &
    & PtclOptPropNcFN, &
    & OutNcFN
  namelist /atm_nml/ &
    & AtmTemp
  namelist /band_nml/ &
    & NBand, WNBnds, BandNBin, KeyMolNum


  a_BndNum(1) = 1
  a_BndNum(2) = 2

  StrSpeNcFN = "strspe.nc"

  InNcFN  = ''

  AtmTemp = 300.0d0

  NBand = 1
  WNBnds    = -999.0d0
  WNBnds(1) = 0.0d0
  WNBnds(2) = 1.0d100

  BandNBin  = 0
  KeyMolNum = 0


  ! Read a namelist file

  call fi_open( CtlFN, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = band_nml, iostat = iostat )
  if ( iostat /= 0 ) then
    stop 'Namelist band_nml is something wrong.'
  end if
  write( 6, nml = band_nml )
  write( 6, * ) "It should be noticed that BandNBin and KeyMolNum are not used in this program."
  !
  close( FileUnit )

  call fi_open( CtlFN2, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = atm_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist atm_nml is something wrong.'
  end if
  write( 6, nml = atm_nml )
  !
  close( FileUnit )

  call fi_open( CtlFN3, "read", FileUnit )
  !
  rewind( FileUnit )
  read( FileUnit, nml = file_nml, iostat = iostat )
  if ( iostat > 0 ) then
    stop 'Namelist file_nml is something wrong.'
  end if
  write( 6, nml = file_nml )
  !
  close( FileUnit )


  WaveNumAxisName = "WaveNum"

  Mode = "read"
  call ni3_open( PtclOptPropNcFN, Mode, InNcID )
  call ni3_inq_dimlen( InNcID, WaveNumAxisName, NWaveNum )
  allocate( w_WaveNum    (NWaveNum) )
  call ni3_get_var( InNcID, WaveNumAxisName, w_WaveNum )
  call ni3_inq_dimlen( InNcID, 'MolNum', NMolNum )
  allocate( m_MolNum    (NMolNum) )
  call ni3_get_var( InNcID, 'MolNum', m_MolNum )
  call ni3_close( InNcID )


  allocate( w_RayScatCoefNonRadAct(NWaveNum) )
  allocate( wm_RayScatCoef(NWaveNum,NMolNum) )
  allocate( w_StrSpe      (NWaveNum) )
  allocate( w_PF          (NWaveNum) )
  allocate( w_Weight      (NWaveNum) )


  Mode = "read"
  call ni3_open( PtclOptPropNcFN, Mode, InNcIDPtcl )
  !
  call ni3_get_att( InNcIDPtcl, "_global_", "comment_dwn_m-1", CommentDWN )
  !
  call ni3_inq_dimlen( InNcIDPtcl, WaveNumAxisName, TmpNum )
  if ( TmpNum /= NWaveNum ) then
    write( 6, * ) 'Array size for coefficients of particles is inappropriate: '
    write( 6, * ) '  ', trim( PtclOptPropNcFN ), ': ', TmpNum
    write( 6, * ) '  ', trim( "Original "     ), ': ', NWaveNum
    stop
  end if
  call ni3_get_var( InNcIDPtcl, "RayScatCoefNonRadAct", w_RayScatCoefNonRadAct )
  !
  call ni3_get_var( InNcIDPtcl, "RayScatCoef"         , wm_RayScatCoef )
  !
  call ni3_inq_dimlen( InNcIDPtcl, "CharNum"      , NChar              )
  call ni3_inq_dimlen( InNcIDPtcl, "PtclNum"      , NParticle          )
  call ni3_inq_dimlen( InNcIDPtcl, "PtclRadiusNum", ParticleNRadiusMax )
  allocate( a_CharNum          (NChar             ) )
  allocate( a_ParticleNum      (NParticle         ) )
  allocate( r_ParticleRadiusNum(ParticleNRadiusMax) )
  allocate( a_ParticleName     (NParticle         ) )
  allocate( a_ParticleNRadius  (NParticle         ) )
  allocate( ra_ParticleRadius(ParticleNRadiusMax,NParticle) )
  allocate( wra_QExt         (NWaveNum,ParticleNRadiusMax,NParticle) )
  allocate( wra_SSA          (NWaveNum,ParticleNRadiusMax,NParticle) )
  allocate( wra_AF           (NWaveNum,ParticleNRadiusMax,NParticle) )
  call ni3_get_var( InNcIDPtcl, "CharNum"          , a_CharNum           )
  call ni3_get_var( InNcIDPtcl, "PtclNum"      , a_ParticleNum       )
  call ni3_get_var( InNcIDPtcl, "PtclRadiusNum", r_ParticleRadiusNum )
  call ni3_get_var( InNcIDPtcl, "PtclName"     , a_ParticleName      )
  call ni3_get_var( InNcIDPtcl, "PtclNRadius"  , a_ParticleNRadius   )
  call ni3_get_var( InNcIDPtcl, "PtclRadius"   , ra_ParticleRadius   )
  call ni3_get_var( InNcIDPtcl, "QExt"             , wra_QExt            )
  call ni3_get_var( InNcIDPtcl, "SSA"              , wra_SSA             )
  call ni3_get_var( InNcIDPtcl, "AF"               , wra_AF              )


  Mode = "read"
  call ni3_open( StrSpeNcFN, Mode, InNcID )
  call ni3_get_att( InNcID, '_global_', 'comment_strspe', CommentStrSpe )
  call ni3_inq_dimlen( InNcID, WaveNumAxisName, TmpNum )
  if ( TmpNum /= NWaveNum ) then
    write( 6, * ) 'Array size for stellar spectrum is inappropriate: '
    write( 6, * ) '  ', trim( StrSpeNcFN      ), ': ', TmpNum
    write( 6, * ) '  ', trim( PtclOptPropNcFN ), ': ', NWaveNum
    stop
  end if
  call ni3_get_var( InNcID, 'InFlux', w_StrSpe )
  call ni3_close( InNcID )


  do l = 1, NWaveNum
    w_PF(l) = PI * PF( w_WaveNum(l), AtmTemp )
  end do


  ! calculation of weight
  w_Weight = w_StrSpe + w_PF


  if ( NBand+1 > MaxNmlArySize ) then
    stop 'Array size is too large.'
  end if
  do n = 1, NBand
    if ( WNBnds(n) > WNBnds(n+1) ) then
      stop 'Band bounds does not increase monotonicaly.'
    end if
  end do


  allocate( b_BandNum         (NBand) )
  allocate( ab_BandWNBnds     (2,NBand) )
  allocate( ab_BandWNIndexBnds(2,NBand) )


  do n = 1, NBand
    b_BandNum(n) = n
  end do


  do n = 1, NBand
    ab_BandWNBnds(1,n) = WNBnds(n  )
    ab_BandWNBnds(2,n) = WNBnds(n+1)
  end do

  ! Look for bound index
  do l = 1, NWaveNum
    if ( w_WaveNum(l) >= ab_BandWNBnds(1,1) ) exit
  end do
  ab_BandWNIndexBnds(1,1) = l
  !
  do n = 1, NBand
    do l = ab_BandWNIndexBnds(1,n), NWaveNum
      if ( w_WaveNum(l) > ab_BandWNBnds(2,n) ) exit
    end do
    ab_BandWNIndexBnds(2,n) = l-1
    if ( n < NBand ) then
      ab_BandWNIndexBnds(1,n+1) = ab_BandWNIndexBnds(2,n) + 1
    end if
  end do


  ! check band
  do n = 1, NBand
    if ( ab_BandWNIndexBnds(2,n) - ab_BandWNIndexBnds(1,n) + 1 <= 0 ) then
      write( 6, * ) 'ERROR: Band ', n, ' has no absorption coefficient.'
      stop
    end if
  end do


  ! calculate band average wavenumber
  allocate( b_BandWN (NBand) )
  do n = 1, NBand
    b_BandWN(n) = 0.0d0
    do l = ab_BandWNIndexBnds(1,n), ab_BandWNIndexBnds(2,n)
      b_BandWN(n) = b_BandWN(n) + w_WaveNum(l)
    end do
    if ( ab_BandWNIndexBnds(2,n)-ab_BandWNIndexBnds(1,n) >= 0 ) then
      b_BandWN(n) = b_BandWN(n) &
        & / ( ab_BandWNIndexBnds(2,n) - ab_BandWNIndexBnds(1,n) + 1 )
    end if
  end do



  allocate( b_BandAveRayScatCoefNonRadAct(NBand) )
  allocate( bm_BandAveRayScatCoef(NBand,NMolNum) )

  call BandAverage( &
    & NWaveNum, w_RayScatCoefNonRadAct, w_Weight, &
    & NBand, ab_BandWNIndexBnds, &
    & b_BandAveRayScatCoefNonRadAct &
    & )
  do m = 1, NMolNum
    call BandAverage( &
      & NWaveNum, wm_RayScatCoef(:,m), w_Weight, &
      & NBand, ab_BandWNIndexBnds, &
      & bm_BandAveRayScatCoef(:,m) &
      & )
  end do

  allocate( bra_BandAveQExt( NBand, ParticleNRadiusMax, NParticle ) )
  allocate( bra_BandAveSSA ( NBand, ParticleNRadiusMax, NParticle ) )
  allocate( bra_BandAveAF  ( NBand, ParticleNRadiusMax, NParticle ) )

  do i = 1, NParticle
    do m = 1, a_ParticleNRadius(i)
      call BandAverage( &
        & NWaveNum, wra_QExt(:,m,i), w_Weight, &
        & NBand, ab_BandWNIndexBnds, &
        & bra_BandAveQExt(:,m,i) &
        & )
      call BandAverage( &
        & NWaveNum, wra_SSA (:,m,i), w_Weight, &
        & NBand, ab_BandWNIndexBnds, &
        & bra_BandAveSSA (:,m,i) &
        & )
      call BandAverage( &
        & NWaveNum, wra_AF  (:,m,i), w_Weight, &
        & NBand, ab_BandWNIndexBnds, &
        & bra_BandAveAF  (:,m,i) &
        & )
    end do
    do m = a_ParticleNRadius(i)+1, ParticleNRadiusMax
      bra_BandAveQExt(:,m,i) = -1.0d100
      bra_BandAveSSA (:,m,i) = -1.0d100
      bra_BandAveAF  (:,m,i) = -1.0d100
    end do
  end do



  ! Output

  Mode = "new"
  call ni3_open( OutNcFN, Mode, OutNcID )

  call ni3_put_att( OutNcID, "_global_", "comment_dwn_m-1", CommentDWN )
  call ni3_put_att( OutNcID, '_global_', 'comment_strspe', CommentStrSpe )

  Name     = "BndNum"
  StdName  = "BndNum"
  LongName = "bound number"
  Units    = "1"
  call ni3_set_dim( OutNcID, Name, NI3_INT   , a_BndNum, &
    & stdname = StdName, longname = LongName, units  = Units )
  !
  Name     = "BandNum"
  StdName  = "BandNum"
  LongName = "band number"
  Units    = "1"
  call ni3_set_dim( OutNcID, Name, NI3_INT, b_BandNum, &
    & stdname = StdName, longname = LongName, units  = Units )
  !
  Name     = "BandWaveNum"
  StdName  = "BandWaveNum"
  LongName = "band wavenumber"
  Units    = "m-1"
  call ni3_set_dim( OutNcID, Name, NI3_DOUBLE, b_BandWN, &
    & stdname = StdName, longname = LongName, units  = Units )
  !
  name    = "MolNum"
  call ni3_set_dim( OutNcID, name, NI3_INT, m_MolNum )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  !
  name    = "CharNum"
  call ni3_set_dim( OutNcID, name, NI3_INT, a_CharNum )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  !
  Name     = "PtclNum"
  call ni3_set_dim( OutNcID, Name, NI3_INT, a_ParticleNum )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  !
  Name     = "PtclRadiusNum"
  call ni3_set_dim( OutNcID, Name, NI3_INT, r_ParticleRadiusNum )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  !
  !
  !
  NDims = 2
  allocate( a_DimNames( NDims ) )
  !
  a_DimNames( 1 ) = "CharNum"
  a_DimNames( 2 ) = "PtclNum"
  Name     = "PtclName"
  call ni3_def_var( OutNcID, Name, NI3_CHAR, NDims, a_DimNames )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  call ni3_put_var( OutNcID, Name, a_ParticleName )
  !
  deallocate( a_DimNames )
  !
  !
  !
  NDims = 1
  allocate( a_DimNames( NDims ) )
  !
  a_DimNames( 1 ) = "PtclNum"
  Name     = "PtclNRadius"
  call ni3_def_var( OutNcID, Name, NI3_INT, NDims, a_DimNames )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  call ni3_put_var( OutNcID, Name, a_ParticleNRadius )
  !
  deallocate( a_DimNames )
  !
  !
  NDims = 2
  allocate( a_DimNames( NDims ) )
  !
  a_DimNames( 1 ) = "PtclRadiusNum"
  a_DimNames( 2 ) = "PtclNum"
  name    = "PtclRadius"
  call ni3_def_var( OutNcID, name, NI3_DOUBLE, NDims, a_DimNames, &
    & stdname = StdName, longname = LongName, units = Units )
  call ni3_cp_atts( InNcIDPtcl, OutNcID, Name, Name )
  call ni3_put_var( OutNcID, name, ra_ParticleRadius )
  !
  deallocate( a_DimNames )


  NDims = 1
  allocate( a_DimNames( NDims ) )
!!$  a_DimNames( 1 ) = "BandNum"
  a_DimNames( 1 ) = "BandWaveNum"
  Name     = "BandAveRayScatCoefNonRadAct"
  StdName  = Name
  LongName = "Band averaged Rayleigh scattering coefficient for non-radiative active molecule"
  Units    = "(molecule m-2)-1"
  call ni3_def_var( OutNcID, Name, NI3_DOUBLE, NDims, a_DimNames, &
    & stdname = StdName, longname = LongName, units = Units )
  call ni3_put_var( OutNcID, Name, b_BandAveRayScatCoefNonRadAct )
  deallocate( a_DimNames )

  NDims = 2
  allocate( a_DimNames( NDims ) )
!!$  a_DimNames( 1 ) = "BandNum"
  a_DimNames( 1 ) = "BandWaveNum"
  a_DimNames( 2 ) = "MolNum"
  Name     = "BandAveRayScatCoef"
  StdName  = Name
  LongName = "Band averaged Rayleigh scattering coefficient"
  Units    = "(molecule m-2)-1"
  call ni3_def_var( OutNcID, Name, NI3_DOUBLE, NDims, a_DimNames, &
    & stdname = StdName, longname = LongName, units = Units )
  call ni3_put_var( OutNcID, Name, bm_BandAveRayScatCoef )
  deallocate( a_DimNames )

  NDims = 3
  allocate( a_DimNames( NDims ) )
  !
!!$  a_DimNames( 1 ) = "BandNum"
  a_DimNames( 1 ) = "BandWaveNum"
  a_DimNames( 2 ) = "PtclRadiusNum"
  a_DimNames( 3 ) = "PtclNum"
  !
  Name     = "BandAveQExt"
  StdName  = Name
  LongName = "Band averaged extinction efficiency factor of particles"
  Units   = "1"
  call ni3_def_var( OutNcID, Name, NI3_DOUBLE, NDims, a_DimNames, &
    & stdname = StdName, longname = LongName, units = Units )
!!$  call ni3_cp_atts( InNcIDPtcl, OutNcID, "QExt", Name )
  call ni3_put_var( OutNcID, Name, bra_BandAveQExt )
  !
  Name     = "BandAveSSA"
  StdName  = Name
  LongName = "Band averaged single scattering albedo of particles"
  Units    = "1"
  call ni3_def_var( OutNcID, Name, NI3_DOUBLE, NDims, a_DimNames, &
    & stdname = StdName, longname = LongName, units = Units )
!!$  call ni3_cp_atts( InNcIDPtcl, OutNcID, "SSA", Name )
  call ni3_put_var( OutNcID, Name, bra_BandAveSSA  )
  !
  Name     = "BandAveAF"
  StdName  = Name
  LongName = "Band averaged asymmetry factor of particles"
  Units    = "1"
  call ni3_def_var( OutNcID, Name, NI3_DOUBLE, NDims, a_DimNames, &
    & stdname = StdName, longname = LongName, units = Units )
!!$  call ni3_cp_atts( InNcIDPtcl, OutNcID, "AF", Name )
  call ni3_put_var( OutNcID, Name, bra_BandAveAF   )



  call ni3_close( InNcIDPtcl )

  call ni3_close( OutNcID )


  deallocate( b_BandAveRayScatCoefNonRadAct )
  deallocate( bm_BandAveRayScatCoef )

  deallocate( w_RayScatCoefNonRadAct )
  deallocate( wm_RayScatCoef )
  deallocate( w_Weight       )


  deallocate( b_BandWN           )
  deallocate( ab_BandWNBnds      )
  deallocate( ab_BandWNIndexBnds )

  deallocate( w_WaveNum )


  write( 6, * ) "Finish"



contains

  !----------------------------------------------------------------------------

  subroutine BandAverage( &
    & NWaveNum, w_Array, w_Weight, &
    & NBand, ab_BandWNIndexBnds, &
    & b_BandAveArray &
    & )

    integer, intent(in ) :: NWaveNum
    real(8), intent(in ) :: w_Array (NWaveNum)
    real(8), intent(in ) :: w_Weight(NWaveNum)
    integer, intent(in ) :: NBand
    integer, intent(in ) :: ab_BandWNIndexBnds(2,NBand)
    real(8), intent(out) :: b_BandAveArray(NBand)


    ! Local variables
    !
    real(8) :: Sum

    integer :: l
    integer :: n


    do n = 1, NBand
      b_BandAveArray(n) = 0.0d0
      Sum = 0.0d0
      do l = ab_BandWNIndexBnds(1,n), ab_BandWNIndexBnds(2,n)
        b_BandAveArray(n) = b_BandAveArray(n) &
          & + w_Array(l) * w_Weight(l)
        Sum = Sum + w_Weight(l)
      end do
      if ( ab_BandWNIndexBnds(2,n)-ab_BandWNIndexBnds(1,n) >= 0 ) then
        b_BandAveArray(n) = b_BandAveArray(n) / Sum
      else
        b_BandAveArray(n) = 0.0d0
      end if
    end do


  end subroutine BandAverage

  !----------------------------------------------------------------------------

end program main
