require "numru/ggraph"
include NumRu

require "./mkwlobj"

pardirs = [
  "../out_hitemp_dwn1e1",
  "../out_hitemp_dwn1e1_abw1.0",
  "../out_hitemp_dwn1e1_nocia",
  "../out_hitemp_dwn1e1_noxsc",
  "../out_hitemp_dwn1e1_co2co025",
  "../out_hitemp_dwn1e1_co2co025",
  "../out_hitemp_dwn1e1_co2co025",
]
labels = [
  'control',
  'air-broadening width x 1.0',
  'no CIA',
  'no XSC',
  'CO2 cutoff 25 cm|-1"',
  'CO2 cutoff 100 cm|-1"',
  'CO2 cutoff 250 cm|-1"',
]

#pardirs = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-60_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-50_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-40_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp-30_dwn1e1",
#  "../../prog03_calc_rte/out_hitran_dwn1e1",
#]
#labels = [
#  'control',
#  'S cutoff 10|-60" m(molecule)|-1"',
#  'S cutoff 10|-50" m(molecule)|-1"',
#  'S cutoff 10|-40" m(molecule)|-1"',
#  'S cutoff 10|-30" m(molecule)|-1"',
#  'HITRAN',
#]

#pardirs = [
#  "../../prog03_calc_rte/out_hitemp_dwn1e2",
#  "../../prog03_calc_rte/out_hitemp_dwn1e1",
#  "../../prog03_calc_rte/out_hitemp_dwn1e0",
#]
#labels = [
#  DCL::csgi(131)+'k=1 cm|-1"',
#  'control ('+DCL::csgi(131)+'k=0.1 cm|-1")',
#  DCL::csgi(131)+'k=0.01 cm|-1"',
#]

pardirs = [
  "../../prog03_calc_rte/out_hitemp_dwn1e1",
  "../../prog03_calc_rte/out_hitemp_dwn1e1_3spc",
  "../../../../radmodels-2018-01-23_test_Venus_Gas-Pollack/k-dist/prog03_calc_rte/out_hitemp_dwn1e1",
]
labels = [
  'control',
  'H2O, CO2, SO2 only',
  'gas vmrs by Pollack et al. (1993)',
]


dirs = [
  "F2635.0_sza037.9_wn02000e2-50000e2",
  "F2635.0_sza077.8_wn02000e2-50000e2",
  "F2635.0_sza180.0_wn02000e2-50000e2"
]
ncfn = "Venus_VIRA+GasVMR+CldMMR+UVabsMMR_H2O_CO2_CO_SO2_HF_OCS_N2_Spectral_Flux.nc"

weights = [0.25, 0.25, 0.5]

ncfnobs = "data/Venus_SWAlbedo_Moroz-etal1985.nc"
vname = "albedo"
gphysobs = GPhys::IO.open( ncfnobs, vname )
gphysobs = gphysobs.copy
wl = gphysobs.coord('wl')
wl.long_name = "wavelength"
vawl = wl.convert_units( Units['micron'] )
gphysobs.axis('wl').set_pos(vawl)


iws = (ARGV[0] || (puts ' WORKSTATION ID (I)  ? ;'; DCL::sgpwsn; gets)).to_i
DCL.gropn(iws)

DCL.sldiv('y',2,1)
DCL.sgpset('isub', 96)   # control character of subscription: '_' --> '`'
DCL.sgpset('lfull',true)
DCL.uzfact(0.7)
DCL.sglset('LCNTL', true)
DCL.sglset('LCLIP', true)



for ipanel in 0..1

  if ipanel == 0 then
    x1 = 0.3
    x2 = 0.6
  else
    x1 = 0.6
    x2 = 4.0
  end
  vpx1 = 0.1; vpx2 = 0.6; vpy1 = 0.15; vpy2 = 0.9
  GGraph.set_fig 'itr'=> 1, 'viewport'=>[vpx1,vpx2,vpy1,vpy2], 'window'=>[x1,x2,0.0,1.0]
  if ipanel == 0 then
    label = 'Moroz et al. (1985)'
    label = 'observation'
  else
    label = nil
  end
  GGraph.line gphysobs, true, 'exchange'=>false, 'index'=>12, 'type'=>2, 'legend'=>label, 'legend_vx'=>0.2, 'legend_vy'=>0.5, 'title'=>''
  GGraph.mark gphysobs, false, 'exchange'=>false, 'index'=>12


  for ipardir in 0..(pardirs.size-1)
    if ipardir == 0 then
      flag_first = true
    else
      flag_first = false
    end

    pardir = pardirs[ipardir]

    for idir in 0..dirs.size-1
      path = pardir + "/" + dirs[idir] + "/" + ncfn

      vname = "RadUwFlux"
      gphysuweach = GPhys::IO.open( path, vname )
      gphysuweach = gphysuweach.cut('Press'=>0)
      vname = "RadDwFlux"
      gphysdweach = GPhys::IO.open( path, vname )
      gphysdweach = gphysdweach.cut('Press'=>0)

      if idir == 0 then
        gphysuw = gphysuweach.copy
        gphysdw = gphysdweach.copy
      else
        gphysuw = gphysuw + gphysuweach.copy * weights[idir]
        gphysdw = gphysdw + gphysdweach.copy * weights[idir]
      end
    end

    gphysuw = mkwlobj( gphysuw )
    gphysdw = mkwlobj( gphysdw )

    nrunmean = 5000
#    if ipardir == 0 then
#      nrunmean = 500
#    elsif ipardir == 1 then
#      nrunmean = 5000
#    else
#      nrunmean = 50000
#    end
    gphysuw = gphysuw.running_mean('WaveNum',nrunmean)
    gphysdw = gphysdw.running_mean('WaveNum',nrunmean)

    gphys = gphysuw / gphysdw

    gphys.long_name = 'albedo'
    gphys.units = '1'


    if ipanel == 0 then
      label = labels[ipardir]
    else
      label = nil
    end
    GGraph.line gphys, false, 'exchange'=>false, 'annotate'=>false, 
                'index'=>(ipardir+1)*10+1, 
                'legend_vx'=>0.2, 'legend'=>label
  end

end

DCL.grcls
