#!/usr/bin/ruby
require "numru/ggraph"
include NumRu

sym   = "Test_Earth_Tropics_H2O_CO2_O3_N2O_CO_CH4_O2_CldMMRI1e+0"
atmnc = "../prog01.0_mkprofile/out/"+sym+".nc"
spenc = "./spe_run_ave/out/Spectral_Flux.nc"

#sym = "Test_Earth_Tropics_H2O_CO2_O3_N2O_CO_CH4_O2"
#sym = "Test_Earth_Tropics_O2"
#spenc = "./spe_run_ave/out/Spectral_Flux.nc"
#atmnc = "../prog01_mkprofile/out/"+sym+".nc"


################################################

def prepare_vars( spenc, vname, wns, wne )

  path = spenc
  gp = GPhys::NetCDF_IO.open( path, vname )

  gp = gp.cut("WaveNum"=>(wns*1e2)..(wne*1e2))

  gp0 = gp.copy

  gp0 = gp0 * 1e2

  gp0 = gp0 * 9.8 / 1004.6
  gp0 = gp0 * 86400

#  namelev = "WaveNum"
#  wn = gp.coord(namelev)
#  gp0 = gp0 * wn

  namelev = "PressLC"
  z = gp.axis(namelev).pos.convert_units( Units['hPa'] )
  gp0.axis(namelev).set_pos(z)

  namelev = "WaveNum"
  z = gp.axis(namelev).pos.convert_units( Units['cm-1'] )
  z.long_name = 'wavenumber'
  gp0.axis(namelev).set_pos(z)

  gp0.long_name = "tendency"

  gpwl0 = gp.copy
  gpwl0 = mkwlobj( gpwl0 )
  gpwl0 = gpwl0 * 9.8 / 1004.6
  gpwl0 = gpwl0 * 86400

  gpwl0 = gpwl0 * 1.0e-6

#  return gp0
  return gpwl0
end

def mkwlobj( gp )

  namelev = "WaveNum"
  wn = gp.coord(namelev)

  gp = gp.copy
  wl = 1.0/wn

#  gp = gp / wl.reshape!(1,wl.val.size)**2
  for k in 0..gp.shape[0]-1
    gp[k,true] = gp[k,true] / wl**2
  end
#  gp = gp * wl

#  wl = wl.convert_units( Units['micron'] )
  wl.long_name = "wavelength"
  vawl = wl.convert_units( Units['micron'] )
#  vawl = VArray.new( wl.val, { "long_name"=>'wavelength', "units"=>wl.units.to_s }, namelev )
  gp.axis(namelev).set_pos(vawl)

  namelev = "PressLC"
  z = gp.axis(namelev).pos.convert_units( Units['hPa'] )
  gp.axis(namelev).set_pos(z)

  gp.long_name = "tendency"

  return gp
end
################################################


#DCL.gropn(-1)
DCL.gropn(-2)
#DCL.sldiv('y',1,4)
DCL.sgpset('lcntl',false)
DCL.sgpset('lfull',true)
DCL.uzfact(0.5)
DCL.sgpset('lfprop',true)
DCL.sglset('LCLIP', true)
DCL.sglset('LCNTL', true)

def draw_panel( spenc, svx1, svx2, svy1, svy2 )

  wns = 10; wne = 50000
  wns = 400; wne = 1200
  wns = 400; wne = 1600
  wns = 1.0/3e-6*1e-2; wne = 500000.0

  x1 = wns; x2 = wne

  x1 = 0; x2 = 2.5

  # for log x axis
#  y1 = 0; y2 = 400
  # for linear x axis
  y1 = 0; y2 = 5e-3
  y1 = 0; y2 = 5e-1

  y1 = 1020; y2 = 1

#  if flagfirst then
#    DCL.sgfrm
#  else
    DCL.grfig
#  end
  DCL.sgsvpt(svx1,svx2,svy1,svy2)
  DCL.sgswnd(x1,x2,y1,y2)
  DCL.grstrn(2)
  DCL.grstrf
  DCL.uzlset( 'labelyl', false )
  DCL.uzlset( 'labelyr', true )
#  DCL.ussttl( 'wavenumber', 'cm|-1"', 'pressure', 'hPa' )
  DCL.ussttl( 'wavenumber', DCL::csgi(163)+'m', 'pressure', 'hPa' )

  vname = 'DRadFluxDPress'

  gp = prepare_vars( spenc, vname, wns, wne )

#  nrunmean = ( 1e0 / (gp.coord('WaveNum').val[1]-gp.coord('WaveNum').val[0]) ).to_i
#  gp = gp.running_mean('WaveNum',nrunmean)

  #  GGraph.tone( gp, true, 'transpose'=>true )
#  DCL.uetone( gp.val.transpose(1,0) )

#  DCL.uipdat( gp.val.transpose(1,0) )

#  zmin = 0.0; zmax = 0.0
#  DCL.uiqcrg(zmin, zmax)
#  print zmin, zmax, "\n"

  DCL.sgscmn(14) # blue-white-red
  
#  lev = [-1e2,-3e1,-1e1,-3e0,-1e0,-3e-1,-1e-1,-3e-2,-1e-2,-3e-3,-1e-3,-3e-4,-1e-4,-3e-5,-1e-5,0,1e-5,3e-5,1e-4,3e-4,1e-3,3e-3,1e-2]
  lev = [-1e1,-7e0,-5e0,-2e0,-1e0,-7e-1,-5e-1,-2e-1,-1e-1,-7e-2,-5e-2,-2e-2,-1e-2,-7e-3,-5e-3,-2e-3,-1e-3,-7e-4,-5e-4,-2e-4,-1e-4,-7e-5,-5e-5,-2e-5,-1e-5,0,1e-2]
  pat = [10999,12999,15999,20999,22999,25999,30999,32999,35999,40999,42999,45999,50999,55999,60999,65999,70999,72999,75999,80999,85999,90999,92999,95999,99999,0]
  
  lev = [-1e-2,-8e-3,-7e-3,-6e-3,-5e-3,-4e-3,-3e-3,-2e-3,-1e-3,0,1e-3,2e-3,3e-3,4e-3,5e-3]
  pat = [10999,15999,20999,25999,30999,35999,40999,45999,50999,55999,55999,60999,65999,70999,75999,80999]
  # 55999 ~ white

  lev = [0,1e-3,2e-3,3e-3,4e-3,5e-3, 6e-3,7e-3,8e-3,9e-3,10e-3,11e-3,12e-3,13e-3,14e-3,15e-3]
  pat = [55999,57999,60999,62999,65999,67999,70999,72999,75999,77999,80999,85999,87999,90999,95999,97999]
  for l in 0..lev.size-1
    lev[l] = lev[l] * 400
  end
  # 55999 ~ white
  
  GGraph.tone( gp, false, 'transpose'=>true, 'lev'=>lev, 'pat'=>pat )
#  GGraph.contour( gp, false, 'transpose'=>true, 'lev'=>[-1e-2] )
#  GGraph.contour( gp, false, 'transpose'=>true, 'lev'=>[0] )
  DCL.usdaxs
  
#  GGraph.color_bar('top'=>true,'vlength'=>(svx2-svx1)*0.7,'vwidth'=>0.01,"landscape"=>true,'units'=>'(K day|-1" cm|-1")','voff'=>0.01,'units_voff'=>-0.03,'vcent'=>0.45,'inffact'=>1.5,'tickintv'=>0)
  GGraph.color_bar('top'=>true,'vlength'=>(svx2-svx1)*0.7,'vwidth'=>0.01,"landscape"=>true,'units'=>'(K day|-1"'+DCL::csgi(163)+'m|-1"'+')','voff'=>0.01,'units_voff'=>-0.03,'vcent'=>0.45,'inffact'=>1.5,'tickintv'=>0)
#  GGraph.color_bar('help'=>true)

#    p gp.coord('WaveNum').val
#    for k in 0..gp.coord('PressLC').val.size-1
#      p gp.cut('WaveNum'=>500).val[k]
#    end

end


def draw_atmtemp( atmnc )

  path = atmnc
  vname = "Temp"
  gp = GPhys::NetCDF_IO.open( path, vname )

  namelev = "Press"
  z = gp.axis(namelev).pos.convert_units( Units['hPa'] )
  gp.axis(namelev).set_pos(z)

#  svx1 =  0.08; svx2 = 0.17
  svx1 =  0.19; svx2 = 0.30
  svy1 =  0.12; svy2 = 0.78

  x1 = 190; x2 = 310; y1 = 1020; y2 = 1

#  if flagfirst then
#    DCL.sgfrm
#  else
    DCL.grfig
#  end
  DCL.sgsvpt(svx1,svx2,svy1,svy2)
  DCL.sgswnd(x1,x2,y1,y2)
  DCL.grstrn(2)
  DCL.grstrf
  DCL.uzlset( 'labelyl', false )
  DCL.uspstx('dxl',50)
  DCL.ussttl( 'temperature', gp.units.to_s, 'pressure', gp.coord('Press').units.to_s )
#  DCL.ussttl( 'temperature', gp.units.to_s, '', '' )


#    DCL.uuslnt(3)
#    val = 300; DCL.uulin( [val,val], [y1,y2] )
#    val = 280; DCL.uulin( [val,val], [y1,y2] )
#    val = 260; DCL.uulin( [val,val], [y1,y2] )
#    val = 240; DCL.uulin( [val,val], [y1,y2] )
#    val = 220; DCL.uulin( [val,val], [y1,y2] )
#    val = 200; DCL.uulin( [val,val], [y1,y2] )

  DCL.uuslnt(1)
  DCL.usgrph( gp.val, gp.coord('Press').val )

end
def draw_atmvmr( atmnc )

  path = atmnc
  vname = "VMR"
  gp = GPhys::NetCDF_IO.open( path, vname )

  namelev = "Press"
  z = gp.axis(namelev).pos.convert_units( Units['hPa'] )
  gp.axis(namelev).set_pos(z)

  path = atmnc
  vname = "PtclMMR"
  gpptcl = GPhys::NetCDF_IO.open( path, vname )
  #
  namelev = "PressM"
  z = gpptcl.axis(namelev).pos.convert_units( Units['hPa'] )
  gpptcl.axis(namelev).set_pos(z)


  svx1 =  0.07; svx2 = 0.17
  svx1 =  0.06; svx2 = 0.17
  svy1 =  0.12; svy2 = 0.78

  # x log axis
#  x1 = 1e-8; x2 = 1e-1; y1 = 1020; y2 = 1
  # x lin axis
  x1 = -8; x2 = 0; y1 = 1020; y2 = 1

#  if flagfirst then
#    DCL.sgfrm
#  else
    DCL.grfig
#  end
  DCL.sgsvpt(svx1,svx2,svy1,svy2)
  DCL.sgswnd(x1,x2,y1,y2)
  # x log axis
#  DCL.grstrn(4)
  # x lin axis
  DCL.grstrn(2)
  DCL.grstrf
  # x log axis
#  DCL.ussttl( 'mix. ratio', gp.units.to_s, 'pressure', gp.coord('Press').units.to_s )
  # x lin axis
  DCL.ussttl( 'log(mix.rat.)', gp.units.to_s, 'pressure', gp.coord('Press').units.to_s )


  DCL.sgstxs( 0.01 )
  DCL.sgstxc(-1)
  ylev = 8.0e-1 * 1.2
  # x log axis
#  x1 = 1e-8; x2 = 1e-3
  # x lin axis
  x1 = -8; x2 = -3
  #-----
#  molname = ["H2O", "CO2", "O3", "N2O", "CO", "CH4", "O2"]
  molname = ['H_2"O', 'CO_2"', 'O_3"', 'N_2"O', 'CO', 'CH_4"', 'O_2"']
  #-----
  (1..gp.coord('MolNum').val.size).reverse_each do |molnum|
    DCL.uuslnt(molnum)
    # x log axis
#    DCL.uulin( gp.cut('MolNum'=>molnum).val, gp.coord('Press').val )
    # x lin axis
    DCL.uulin( (gp+1e-30).log10.cut('MolNum'=>molnum).val, gp.coord('Press').val )
    DCL.sglset('LCLIP', false)
    ylev = ylev/1.2
    DCL.uulin( [x1,x2], [ylev,ylev] )
    # x log axis
#    DCL.sgtxu( x2*1.5, ylev, molname[molnum-1] )
    # x lin axis
    DCL.sgtxu( x2+1.5, ylev, molname[molnum-1] )
    DCL.sglset('LCLIP', true)
  end
  #-----
  molname = ['water', 'ice']
  #-----
  DCL.uuslni(5)
  (1..gpptcl.coord('PtclNum').val.size).reverse_each do |molnum|
    DCL.uuslnt(molnum)
    # x log axis
    #    DCL.uulin( gpptcl.cut('PtclNum'=>molnum).val, gpptcl.coord('Press').val )
    # x lin axis
    DCL.uulin( (gpptcl+1e-10).log10.cut('PtclNum'=>molnum).val, gpptcl.coord('PressM').val )
    DCL.sglset('LCLIP', false)
    ylev = ylev/1.2
    DCL.uulin( [x1,x2], [ylev,ylev] )
    # x log axis
    #    DCL.sgtxu( x2*1.5, ylev, molname[molnum-1] )
    # x lin axis
    DCL.sgtxu( x2+1.5, ylev, molname[molnum-1] )
    DCL.sglset('LCLIP', true)
  end
  DCL.uuslni(1)
  #-----
  DCL.sgstxc(0)
  DCL.uuslnt(1)

#  DCL.uxaxdv( 'b', 1.0, 2.0 )
#  DCL.uxaxdv( 't', 1.0, 2.0 )
#  DCL.ulylog( 'l', 3, 3 )
#  DCL.ulylog( 'r', 3, 3 )

  DCL.uspstx('dxl',2)
  DCL.usdaxs

end

draw_atmvmr( atmnc )
draw_atmtemp( atmnc )


delsvy = 0.108
panelheight = 0.095
panelheight = 0.09
svy1 = -0.025

svx1 = 0.2; svx2 = 0.65
svx1 = 0.325; svx2 = 0.65

svy1 =  0.12; svy2 = 0.78

draw_panel( spenc, svx1, svx2, svy1, svy2 )

DCL.grcls
