#!/usr/bin/ruby
require "numru/ggraph"
include NumRu
require "./wl2rgb"

$flag_ptcl = true

strnc = "../prog02.5_calc_stellarspectrum/out-dwn1e1/solar_flux_Gueymard2004_1366.1Wm-2.nc"
sym   = "Mars_Seiff1982_H2O-0.0_CO2-0.95_O3-0.0"
sym   = "Mars_Seiff1982+DustMMR_H2O-0.0_CO2-0.95_O3-0.0_DOD0.0"
spenc = "../prog03_calc_rte/out-dwn1e1/"+sym+"_Spectral_Flux.nc"
atmnc = "../prog01.0_mkprofile/out/"+sym+".nc"

press = [1000e2, 300e2, 100e2, 30e2, 10e2, 3e2, 1e2, 0]
press = [10e2, 3e2, 1e2, 0.3e2, 0.1e2, 0.03e2, 0.01e2, 0]

$ptclname = ['dust']

$profile_y1 = 10
$profile_y2 = 0.01

################################################

def prepare_vars( spenc, press, vname, flagpress = true )

  path = spenc
  gp = GPhys::NetCDF_IO.open( path, vname )

  if flagpress then
    gp0 = gp.cut("Press"=>press)
  else
    gp0 = gp
  end
  gp0 = gp0.copy

  gp0 = gp0 * 1e2

#  namelev = "WaveNum"
#  wn = gp.coord(namelev)
#  gp0 = gp0 * wn

  namelev = "WaveNum"
  z = gp.axis(namelev).pos.convert_units( Units['cm-1'] )
  z.long_name = 'wavenumber'
  gp0.axis(namelev).set_pos(z)

  gp0.long_name = "flux"


  if flagpress then
    gpwl0 = gp.cut("Press"=>press)
  else
    gpwl0 = gp
  end
  gpwl0 = gpwl0.copy
  gpwl0 = mkwlobj( gpwl0 )

#  return gp0
  return gpwl0
end

def mkwlobj( gp )

  namelev = "WaveNum"
  wn = gp.coord(namelev)

  gp = gp.copy
  wl = 1.0/wn

  gp = gp / wl**2
#  gp = gp * wl

#  wl = wl.convert_units( Units['micron'] )
  wl.long_name = "wavelength"
  vawl = wl.convert_units( Units['micron'] )
#  vawl = VArray.new( wl.val, { "long_name"=>'wavelength', "units"=>wl.units.to_s }, namelev )
  gp.axis(namelev).set_pos(vawl)

  gp.long_name = "flux"

  # conversion from Wm-2 m-1 to Wm-2 (micron)-1
  gp = gp * 1e-6
#  gp.units = 'Wm|-2"(micron)|-1"'
  gp.units = 'Wm|-2"('+DCL::csgi(163)+'m)|-1"'

  return gp
end
################################################


#DCL.gropn(-1)
DCL.gropn(-2)
#DCL.sldiv('y',1,4)
DCL.sgpset('lcntl',false)
DCL.sgpset('lfull',true)
DCL.uzfact(0.5)
DCL.sgpset('lfprop',true)
DCL.sglset('LCLIP', true)
DCL.sglset('LCNTL', true)

def draw_panel( spenc, press_target, svx1, svx2, svy1, svy2, strnc, flagfirst, flaglast=false )

#  vname = "InFlux"
#  path = pfdir + "/" + "pf0300K.nc"
#  gppf300 = prepare_vars( path, 0.0, vname, false ) * 3.141592
#  path = pfdir + "/" + "pf0280K.nc"
#  gppf280 = prepare_vars( path, 0.0, vname, false ) * 3.141592
#  path = pfdir + "/" + "pf0260K.nc"
#  gppf260 = prepare_vars( path, 0.0, vname, false ) * 3.141592
#  path = pfdir + "/" + "pf0240K.nc"
#  gppf240 = prepare_vars( path, 0.0, vname, false ) * 3.141592
#  path = pfdir + "/" + "pf0220K.nc"
#  gppf220 = prepare_vars( path, 0.0, vname, false ) * 3.141592
#  path = pfdir + "/" + "pf0200K.nc"
#  gppf200 = prepare_vars( path, 0.0, vname, false ) * 3.141592

  wns = 10; wne = 50000
  wns = 400; wne = 1200
  wns = 400; wne = 1600

#  itr = 1
#itr = 2
#  itr = 3

  x1 = wns; x2 = wne
  # for log x axis
#  y1 = 0; y2 = 400
  # for linear x axis
  y1 = 0; y2 = 5e-3
  y1 = 0; y2 = 5e-1
  y1 = 0; y2 = 2250
  y1 = 0; y2 = 1250
  y1 = 0; y2 =  400
  y1 = 0; y2 =  110
  y1 = 0; y2 =  150

#  x1 = 1.0/(x2*1e2)*1e6; x2 = 1.0/(x1*1e2)*1e6
  x1 = 0; x2 = 4.0
  x1 = 0; x2 = 2.5
                                          
#  GGraph.set_fig 'itr'=>itr, 'viewport'=>[svx1,svx2,svy1,svy2], 'window'=>[x1,x2,y1,y2]
#  GGraph.line( gp, true, "title"=>"", "annotate"=>false, "index"=>10 )

#  if flagfirst then
#    DCL.sgfrm
#  else
    DCL.grfig
#  end
  DCL.sgsvpt(svx1,svx2,svy1,svy2)
  DCL.sgswnd(x1,x2,y1,y2)
  DCL.grstrn(1)
  DCL.grstrf
  if !flagfirst then
    DCL.uzlset( 'labelxb', false )
  end
  DCL.uzlset( 'labelyl', false )
  DCL.uzlset( 'labelyr', true )
#  DCL.uxsttl( 'b', 'wavenumber (cm-1)', 0.0 )
  if flaglast then
##    DCL.ussttl( 'wavenumber', 'cm-1', 'flux', 'Wm-2' )
#    DCL.ussttl( 'wavenumber', 'cm|-1"', 'up.flux', 'Wm|-2"(cm|-1")|-1"' )
##    DCL.uysttl( 'r', 'flux (Wm-2)', 0.0 )
#    DCL.ussttl( 'wavelength', 'micron', 'dir.flux', 'Wm|-2"(micron)|-1"' )
    DCL.ussttl( 'wavelength', DCL::csgi(163)+'m', 'up.flux', 'Wm|-2"('+DCL::csgi(163)+'m)|-1"' )
  else
#    DCL.ussttl( 'wavenumber', 'cm|-1"', 'up.flux', '' )
#    DCL.ussttl( 'wavelength', 'micron', 'dir.flux', '' )
    DCL.ussttl( 'wavelength', DCL::csgi(163)+'m', 'up.flux', '' )
#    DCL.uysttl( 'r', 'flux (Wm-2)', 0.0 )
  end

#  DCL.uuslnt(3)
#  gppf = gppf300
##  DCL.usgrph(gppf.coord('WaveNum').val,gppf.val)
#  DCL.uulin(gppf.coord('WaveNum').val,gppf.val)
#  gppf = gppf280
##  DCL.usgrph(gppf.coord('WaveNum').val,gppf.val)
#  DCL.uulin(gppf.coord('WaveNum').val,gppf.val)
#  gppf = gppf260
##  DCL.usgrph(gppf.coord('WaveNum').val,gppf.val)
#  DCL.uulin(gppf.coord('WaveNum').val,gppf.val)
#  gppf = gppf240
##  DCL.usgrph(gppf.coord('WaveNum').val,gppf.val)
#  DCL.uulin(gppf.coord('WaveNum').val,gppf.val)
#  gppf = gppf220
##  DCL.usgrph(gppf.coord('WaveNum').val,gppf.val)
#  DCL.uulin(gppf.coord('WaveNum').val,gppf.val)
#  gppf = gppf200
##  DCL.usgrph(gppf.coord('WaveNum').val,gppf.val)
#  DCL.uulin(gppf.coord('WaveNum').val,gppf.val)

  #  vname = 'RadDwFlux'
#  gp = prepare_vars( spenc, 0.0, vname )
  vname = 'InFlux'
  gp = prepare_vars( strnc, 0.0, vname, false )
#  nrunmean = 100
##  nrunmean = 1000
#  gp = gp.running_mean('WaveNum',nrunmean)


  # AM0 spectrum
#  DCL.uuslni(100+1)
##  DCL.uuslnt(3)
#  DCL.uulin(gp.coord('WaveNum').val,gp.val)
#  DCL.uuslni(1)
##  DCL.uuslnt(1)

  if flagfirst then
    DCL.sgstxs( 0.01 )
    DCL.sgtxu( 550, 440e-3, '300 K' )
    DCL.sgtxu( 575, 360e-3, '280 K' )
    DCL.sgtxu( 600, 280e-3, '260 K' )
    DCL.sgtxu( 625, 200e-3, '240 K' )
    DCL.sgtxu( 650, 120e-3, '220 K' )
    DCL.sgtxu( 675,  40e-3, '200 K' )
  end

  DCL.uuslnt(1)
#  DCL.usgrph(gp.coord('WaveNum').val,gp.val)

  vname = 'RadDwFlux'
  vname = 'RadUwFlux'
  path = spenc
  gp = GPhys::NetCDF_IO.open( path, vname )
  na_press = gp.coord("Press").val
  residual = 1.0e30
  for press1 in na_press
    if ( residual > ( press1-press_target ).abs )
      residual = ( press1-press_target ).abs
      press = press1
    end
  end
  gp = prepare_vars( spenc, press, vname )
#  nrunmean = ( 1e0 / (gp.coord('WaveNum').val[1]-gp.coord('WaveNum').val[0]) ).to_i
#  gp = gp / Math::cos(Math::PI/180.0*60.0)
#  gp = gp / Math::cos(Math::PI/180.0*75.0)
  nrunmean = 10
  nrunmean = 1000
  gp = gp.running_mean('WaveNum',nrunmean)


  wl = gp.coord('WaveNum').val
  rgb = wl2rgb( wl*1e3 )
  dx = (wl[-1]-wl[0])/wl.size
  vpx = NArray.sfloat(4)
  vpy = NArray.sfloat(4)

#  for i in 0..wl.size-1
#    vpx = [wl[i],wl[i]+dx,wl[i]+dx,wl[i]] ; vpy = [y1,y1,gp.val[i],gp.val[i]]
#    r = rgb[i,0].to_i ; g = rgb[i,1].to_i ; b = rgb[i,2].to_i
#    if ( r >= 0 ) && ( g >= 0 ) && ( b >= 0 ) then
#      DCL::sgtnxu(vpx,vpy,999,DCL::isgrgb(r,g,b))
#    end
#  end

  i = 0
  di = 10
  while i <= wl.size-1-di
    vpx = [wl[i],wl[i+di],wl[i+di],wl[i]] ; vpy = [y1,y1,gp.val[i+di],gp.val[i]]
    r = rgb[i,0].to_i ; g = rgb[i,1].to_i ; b = rgb[i,2].to_i
    if ( r >= 0 ) && ( g >= 0 ) && ( b >= 0 ) then
      DCL::sgtnxu(vpx,vpy,999,DCL::isgrgb(r,g,b))
    end
    i = i + di
  end


  DCL.uulin(gp.coord('WaveNum').val,gp.val)

  DCL.usdaxs

  DCL.sglset('LCLIP', false)
  presslabel = sprintf("%6.2f", press*1e-2)
  presslabel = presslabel + ' hPa'
  DCL.sgstxc(-1)
#  DCL.sgtxu( 1250, 420e-3, presslabel )
#  DCL.sgtxu( x1+(x2-x1)*0.7, y2+(y2-y1)*0.1, presslabel )
  DCL.sgtxu( x1, y2+(y2-y1)*0.09, presslabel )
  DCL.sgstxc(0)
  DCL.sglset('LCLIP', true)

end


def draw_atmtemp( atmnc )

  path = atmnc
  vname = "Temp"
  gp = GPhys::NetCDF_IO.open( path, vname )

  namelev = "Press"
  z = gp.axis(namelev).pos.convert_units( Units['hPa'] )
  gp.axis(namelev).set_pos(z)

#  svx1 =  0.08; svx2 = 0.17
  svx1 =  0.19; svx2 = 0.30
  svy1 =  0.12; svy2 = 0.78

  x1 = 190; x2 = 310
  y1 = 1020; y2 = 1
  x1 = 120; x2 = 220
  y1 = $profile_y1; y2 = $profile_y2

#  if flagfirst then
#    DCL.sgfrm
#  else
    DCL.grfig
#  end
  DCL.sgsvpt(svx1,svx2,svy1,svy2)
  DCL.sgswnd(x1,x2,y1,y2)
  DCL.grstrn(2)
  DCL.grstrf
  DCL.uzlset( 'labelyl', false )
  DCL.uspstx('dxl',50)
  DCL.ussttl( 'temperature', gp.units.to_s, 'pressure', gp.coord('Press').units.to_s )
#  DCL.ussttl( 'temperature', gp.units.to_s, '', '' )


#    DCL.uuslnt(3)
#    val = 300; DCL.uulin( [val,val], [y1,y2] )
#    val = 280; DCL.uulin( [val,val], [y1,y2] )
#    val = 260; DCL.uulin( [val,val], [y1,y2] )
#    val = 240; DCL.uulin( [val,val], [y1,y2] )
#    val = 220; DCL.uulin( [val,val], [y1,y2] )
#    val = 200; DCL.uulin( [val,val], [y1,y2] )
#    DCL.uuslnt(1)

  DCL.usgrph( gp.val, gp.coord('Press').val )

end
def draw_atmvmr( atmnc )

  path = atmnc
  vname = "VMR"
  gp = GPhys::NetCDF_IO.open( path, vname )

  namelev = "Press"
  z = gp.axis(namelev).pos.convert_units( Units['hPa'] )
  gp.axis(namelev).set_pos(z)

  path = atmnc
  vname = "PtclMMR"
  gpptcl = GPhys::NetCDF_IO.open( path, vname )
  #
  namelev = "PressM"
  z = gpptcl.axis(namelev).pos.convert_units( Units['hPa'] )
  gpptcl.axis(namelev).set_pos(z)


  svx1 =  0.07; svx2 = 0.17
  svx1 =  0.06; svx2 = 0.17
  svy1 =  0.12; svy2 = 0.78

  # x log axis
#  x1 = 1e-8; x2 = 1e-1; y1 = 1020; y2 = 1
  # x lin axis
  x1 = -8; x2 = 0
  y1 = 1020; y2 = 1
  y1 = $profile_y1; y2 = $profile_y2

#  if flagfirst then
#    DCL.sgfrm
#  else
    DCL.grfig
#  end
  DCL.sgsvpt(svx1,svx2,svy1,svy2)
  DCL.sgswnd(x1,x2,y1,y2)
  # x log axis
#  DCL.grstrn(4)
  # x lin axis
  DCL.grstrn(2)
  DCL.grstrf
  # x log axis
#  DCL.ussttl( 'mix. ratio', gp.units.to_s, 'pressure', gp.coord('Press').units.to_s )
  # x lin axis
  DCL.ussttl( 'log(mix.rat.)', gp.units.to_s, 'pressure', gp.coord('Press').units.to_s )


  DCL.sgstxs( 0.01 )
  DCL.sgstxc(-1)
  ylev = 8.0e-1 * 1.2
  ylev = y2 * 0.8 * 1.2
  # x log axis
#  x1 = 1e-8; x2 = 1e-3
  # x lin axis
  x1 = -8; x2 = -3
  #-----
#  molname = ["H2O", "CO2", "O3", "N2O", "CO", "CH4", "O2"]
  molname = ['H_2"O', 'CO_2"', 'O_3"', 'N_2"O', 'CO', 'CH_4"', 'O_2"']
  #-----
  (1..gp.coord('MolNum').val.size).reverse_each do |molnum|
    DCL.uuslnt(molnum)
    # x log axis
#    DCL.uulin( gp.cut('MolNum'=>molnum).val, gp.coord('Press').val )
    # x lin axis
    DCL.uulin( (gp+1e-30).log10.cut('MolNum'=>molnum).val, gp.coord('Press').val )
    DCL.sglset('LCLIP', false)
    ylev = ylev/1.2
    DCL.uulin( [x1,x2], [ylev,ylev] )
    # x log axis
#    DCL.sgtxu( x2*1.5, ylev, molname[molnum-1] )
    # x lin axis
    DCL.sgtxu( x2+1.5, ylev, molname[molnum-1] )
    DCL.sglset('LCLIP', true)
  end
  #-----
  #-----
  DCL.uuslni(5)
  if $flag_ptcl then
    (1..gpptcl.coord('PtclNum').val.size).reverse_each do |molnum|
      DCL.uuslnt(molnum)
      # x log axis
      #    DCL.uulin( gpptcl.cut('PtclNum'=>molnum).val, gpptcl.coord('Press').val )
      # x lin axis
      DCL.uulin( (gpptcl+1e-10).log10.cut('PtclNum'=>molnum).val, gpptcl.coord('PressM').val )
      DCL.sglset('LCLIP', false)
      ylev = ylev/1.2
      DCL.uulin( [x1,x2], [ylev,ylev] )
      # x log axis
      #    DCL.sgtxu( x2*1.5, ylev, molname[molnum-1] )
      # x lin axis
      DCL.sgtxu( x2+1.5, ylev, $ptclname[molnum-1] )
      DCL.sglset('LCLIP', true)
    end
  end
  DCL.uuslni(1)
  #-----
  DCL.sgstxc(0)
  DCL.uuslnt(1)

#  DCL.uxaxdv( 'b', 1.0, 2.0 )
#  DCL.uxaxdv( 't', 1.0, 2.0 )
#  DCL.ulylog( 'l', 3, 3 )
#  DCL.ulylog( 'r', 3, 3 )

  DCL.uspstx('dxl',2)
  DCL.usdaxs

end

draw_atmvmr( atmnc )
draw_atmtemp( atmnc )

#delsvy = 0.15
#panelheight = 0.12
#svy1 = -0.07

delsvy = 0.108
panelheight = 0.095
panelheight = 0.09
svy1 = -0.025

svx1 = 0.2; svx2 = 0.65
svx1 = 0.325; svx2 = 0.65


for i in 0..(press.size-1)
  flagfirst = false
  flaglast  = false
  if i == 0 then
    flagfirst = true
  elsif i == press.size-1 then
    flaglast = true
  end
  svy1 = svy1 + delsvy
  svy2 = svy1 + panelheight
  draw_panel( spenc, press[i], svx1, svx2, svy1, svy2, strnc, flagfirst, flaglast )

end

DCL.grcls
